static char version[] =
"hcal version 1.0 - postscript hebrew calendar generator\n\n\
copyright 1994,1995 - Steven Weintraub";

/*
 
    hcal version 1.0 - postscript hebrew calendar generator
    copyright 1994,1995 - Steven Weintraub
 
    This program is created and distribed by Steven Weintraub. It
    can be freely distributed without permission as long as this
    head is retained in all files it appears and the LICENCE file
    accompanies it.
 
*/

#include "hcal.h"

#if defined(PROTOTYPES)
void cmd_data(void) {
#else
void cmd_data() {
#endif
	int		 choice;
	cur_slist_t	*clist;
	city_t		*cptr;
	int		 loop;
	int		 selection;

	clist = NULL;
	clist = cur_slist_add(clist,mk_string("Change city you are in"));
	clist = cur_slist_add(clist,mk_string("Edit city in list"));
	clist = cur_slist_add(clist,mk_string("Add city to list"));
	clist = cur_slist_add(clist,mk_string("Delete city from list"));
	selection = 1;
	(void)cur_slist_fancy("City Menu",clist,selection,&selection);
	cur_slist_free(clist);
	switch (selection) {
		case 1:
		case 2:
		case 4:
			(void)cur_slist_fancy("Which City",city_slist,
					city_number,&choice);
			for (cptr = cities,loop = 1;
					loop < choice;loop++,cptr = cptr->next)
				;
			switch(selection) {
				case 1:
					city = cptr;
					city_number = choice;
					break;
				case 2:
					tdirty = edit_city(cptr);
					break;
				case 4:
					if (!cptr->next && !cptr->last) {
						cur_msg_win(
		"This is the last city of record, no deletion possible");
						break;
					}
					free(cptr->name);
					if (cptr->slist_ptr->next)
						cptr->slist_ptr->next->last =
							cptr->slist_ptr->last;
					if (cptr->slist_ptr->last)
						cptr->slist_ptr->last->next =
							cptr->slist_ptr->next;
					else
						city_slist =
							cptr->slist_ptr->next;
					free(cptr->slist_ptr);
					if (cptr->next)
						cptr->next->last = cptr->last;
					if (cptr->last)
						cptr->last->next = cptr->next;
					else
						cities = cptr->next;
					if (cptr == city) {
						if (city->next)
							city = city->next;
						else
							city = city->last;
					}
					if (city_number > loop)
						city_number--;
					break;
				}
			break;
		case 3:
			tdirty = add_city();
			break;
	}
}

#if defined(PROTOTYPES)
void cmd_edit(void) {
#else
void cmd_edit() {
#endif
	int	   	 current;
	info_t		*iptr;
	cur_alist_t	*list;
	int		 loop;
	day_data_t	*this_day;
#ifdef XCURSES
	cur_wlist_t	*cptr;
#endif

	current = 1;
	asking = YES;
	changed = YES;
#ifdef XCURSES
	cptr = (cur_wlist_t *)-1;
#endif
	while (asking) {
		if (changed || (changed_all && show_all)) {
			list = NULL;
			list = cur_alist_add(list,TYPE_ADD,NULL);
			list = cur_alist_add(list,TYPE_ADD_MITZVAH,NULL);
			list = cur_alist_add(list,TYPE_EDIT_MINYAN,NULL);
			list = cur_alist_add(list,TYPE_ADD_MISC,NULL);
			list = cur_alist_add(list,TYPE_DELETE,NULL);
			if (show_all)
				list = cur_alist_add(list,TYPE_SHOW_SOME,NULL);
			else
				list = cur_alist_add(list,TYPE_SHOW_ALL,NULL);
			list = cur_alist_add(list,TYPE_QUIT,NULL);
			for (loop = 1;loop <= numdays;loop++) {
				this_day = day + loop;
				if (show_all && day[loop].jmonth &&
						*day[loop].jmonth)
					list = cur_alist_add(list,
							TYPE_JDATE | loop,
							(void *)this_day);
				if (show_all && day[loop].shaharit.word1)
					list = cur_alist_add(list,
							TYPE_SHAHARIT | loop,
							(void *)this_day);
				if (day[loop].shabbat)
					list = cur_alist_add(list,
							TYPE_SHABBAT | loop,
							(void *)this_day);
				for (iptr = this_day->info;
						iptr;
						iptr = iptr->next)
					list = cur_alist_add(list,
							TYPE_INFO | loop,
							(void *)iptr);
				if (show_all && day[loop].holiday)
					list = cur_alist_add(list,
							TYPE_HOLIDAY | loop,
							(void *)this_day);
				if (show_all && day[loop].chanukah)
					list = cur_alist_add(list,
							TYPE_CHANUKAH | loop,
							(void *)this_day);
				if (show_all && day[loop].omer)
					list = cur_alist_add(list,
							TYPE_OMER | loop,
							(void *)this_day);

				if (show_all && day[loop].mincha.word1)
					list = cur_alist_add(list,
							TYPE_MINCHA | loop,
							(void *)this_day);
				if (show_all && day[loop].candles.word1)
					list = cur_alist_add(list,
							TYPE_CANDLES | loop,
							(void *)this_day);
				if (day[loop].mitzvah)
					list = cur_alist_add(list,
							TYPE_MITZVAH | loop,
							(void *)this_day);
				if (show_all && day[loop].mariv.word1)
					list = cur_alist_add(list,
							TYPE_MARIV | loop,
							(void *)this_day);
			}
			changed = NO;
			changed_all = NO;
		}
#ifdef XCURSES
		cur_cptr_safe = cptr;
#endif
		current = cur_alist_ask(
		"Select Action or Item To Edit 'a' to add or 'd' to delete",
				list,current,"da",mprc_edit,mprt_edit);
#ifdef XCURSES
		cptr = cur_cptr_safe;
#endif
		if (changed || !asking || (changed_all && show_all))
			cur_alist_free(list);
	}
#ifdef XCURSES
	cur_alist_back(cptr);
#endif
}

#if defined(PROTOTYPES)
void cmd_month(void) {
#else
void cmd_month() {
#endif
	int	loop;
	char	new_month[MAX_STR];
	char	temp_str[MAX_STR];
	int	year;

	if (dirty) {
		cur_msg_win("Current month's data is not saved");
		if (!cur_ask_y_n(
	"Resetting month will lose current data, continue without saving it",
				"Continue without saving current month's data"))
			return;
	}
	draw_month = NO;
	free_month();
	cur_slist_fancy("Choose new month",month_menu,current_month + 1,
			&current_month);
	current_month--;
	if (year = cur_ask_num_lud("Year for the Calendar","Year",1760,3000,
			current_year))
		current_year = year;
	set_month(current_month,current_year);
	draw_month = YES;
}

#if defined(PROTOTYPES)
void cmd_print(void) {
#else
void cmd_print() {
#endif
	FILE	*print_file;
	FILE	*schedule_file;

	if (!(print_file = get_file("w",
			"What file do you wish to open for printing",
			print_file_name)))
		return;
	if (!(schedule_file = get_file("w",
			"What file do you wish to open for schedule file",
			schedule_file_name)))
		return;

	print_out(print_file,schedule_file);
	return;
}

#if defined(PROTOTYPES)
void cmd_quit(void) {
#else
void cmd_quit() {
#endif
	if (dirty) {
		cur_msg_win("Current month's data is not saved");
		if (cur_ask_y_n(
		"Quitting will lose current data, quit without saving it",
				"Quit without saving current month's data"))
			dirty = NO;
	}
}

#if defined(PROTOTYPES)
void cmd_read(void) {
#else
void cmd_read() {
#endif
	cur_strd("What file do you wish to read in",save_file_name,save_file_name);
	(void) read_file(save_file_name,YES);
}

#define  OUTPUT(string) fprintf(output_file,"%s %2d   %s\n", \
					month[current_month],loop,(string))
#define BOUTPUT(string) fprintf(output_file,"%s %2d * %s\n", \
					month[current_month],loop,(string))

#if defined(PROTOTYPES)
static void poutput(FILE *file, char *string) {
#else
static void poutput(file,string) FILE *file; char *string; {
#endif
	char	*last;
	int	 len;
	int	 loop;
	char	*sptr;
	char	*start;

	len = strlen(month[current_month]) + 5;
	for (start = string,sptr = string;*sptr;sptr++) {
		if (*sptr == ' ') {
			*sptr = '\0';
			if (80 - len - strlen(start) < 0) {
				*last = '\0';
				for (loop = 0;loop < len;loop++)
					fputc(' ',file);
				fprintf(file," %s\n",start);
				*last = ' ';
				start = sptr + 1;
			}
			*sptr = ' ';
			last = sptr;
		}
	}
	if (*start) {
		for (loop = 0;loop < len;loop++)
			fputc(' ',file);
		fprintf(file," %s\n",start);
	}
}

#if defined(PROTOTYPES)
void cmd_save(void) {
#else
void cmd_save() {
#endif
	city_t		 *cptr;
	int		  loop;
	info_t		 *iptr;
	int		  item;
	int		  mark;
	FILE		 *output_file;
	char		**ptr;
	char		  string[MAX_STR];
	day_data_t	 *tday;
	FILE		 *template_file;

	if (!(output_file = get_file("w",
			"What file do you wish to open for outputing",
			save_file_name)))
		return;
	template_file = NULL;
	if (tdirty) {
		if (cur_ask_y_n(
			"Basic information change - update template file",
				"Update template file"))
			template_file = get_file("w",
				"What file do you wish to open for template",
				 template_file_name);
	}
	fprintf(output_file,"Month %s\n",month[current_month]);
	fprintf(output_file,"Jdate %s %d\n",day[1].jmonth, day[1].jday);
	if (template_file) {
		for (cptr = cities;cptr;cptr = cptr->next)
			print_city(template_file,cptr);
		fprintf(template_file,"City %s\n\n",cities->name);
		print_minyan(template_file,NO);
	}
	print_city(output_file,city);
	print_minyan(output_file,YES);

	for (loop = 1;loop <= numdays;loop++) {
		tday = day + loop;
		if (tday->jmonth) {
			sprintf(string,"Is {%s} %2d %4d",tday->jmonth,tday->jday,
					tday->jyear);
			OUTPUT(string);
		}
		if (tday->holiday)
			OUTPUT("Holiday");
		if (tday->candles.word1) {
			if (tday->candles.word1 == TIME_CANDLES_EARLY)
				OUTPUT("Candles early");
			else if (tday->candles.word1 == TIME_CANDLES_LATE)
				OUTPUT("Candles late");
			else
				OUTPUT("Havdalah");
		}
		if (tday->omer) {
			sprintf(string,"Omer %d",tday->omer);
			OUTPUT(string);
		}
		if (tday->chanukah) {
			sprintf(string,"Chanukah %d",tday->chanukah);
			OUTPUT(string);
		}
		if (tday->shabbat) {
			sprintf(string,"Shabbat {%s} {%s} {%s}",
					tday->shabbat->name,
					tday->shabbat->torah,
					tday->shabbat->prophet);
			OUTPUT(string);
			if (tday->shabbat->schedule && *tday->shabbat->schedule)
				poutput(output_file,tday->shabbat->schedule);
		}
		if (tday->mitzvah) {
			if (tday->mitzvah->place == 1)
				sprintf(string,"%s Mitzvah of %s",
						mitztypes[tday->mitzvah->type],
						tday->mitzvah->who);
			else
				sprintf(string,"%s Mitzvah %s",
						mitztypes[tday->mitzvah->type],
						tday->mitzvah->who);
			OUTPUT(string);
			if (tday->mitzvah->schedule && *tday->mitzvah->schedule)
				poutput(output_file,tday->mitzvah->schedule);
		}
		for (iptr = tday->info;iptr;iptr = iptr->next) {
			string[0] = '\0';
			if (iptr->time.word1)
				OUTPUT(format_time(loop,&iptr->time,TIME_FORMAT_ACTUAL));
			strcat(string,iptr->calendar);
			if (iptr->bold)
				BOUTPUT(string);
			else
				OUTPUT(string);
			if (iptr->schedule && * iptr->schedule)
				poutput(output_file,iptr->schedule);
		}
	}
	fclose(output_file);
	if (template_file)
		{
		tdirty = NO;
		fclose(template_file);
		}
	dirty = NO;
}
