static char version[] =
"hcal version 1.0 - postscript hebrew calendar generator\n\n\
copyright 1994,1995 - Steven Weintraub";

/*
 
    hcal version 1.0 - postscript hebrew calendar generator
    copyright 1994,1995 - Steven Weintraub
 
    This program is created and distribed by Steven Weintraub. It
    can be freely distributed without permission as long as this
    head is retained in all files it appears and the LICENCE file
    accompanies it.
 
*/

#include "cur.h"

#if defined(PROTOTYPES)
int cur_mlist_verify_all(cur_mlist_t * mfirst,int cur_mverify(cur_mlist_t *)) {
#else
int cur_mlist_verify_all(mfirst,cur_mverify) 
cur_mlist_t *mfirst;int (*cur_mverify)(); {
#endif
	cur_mlist_t *mptr;
	char string[300];

	for (mptr = mfirst;mptr;mptr = mptr->next) {
		if (!mptr->enterable)
			continue;
		if (mptr->type == CUR_MENU_DATA && mptr->must_have &&
				!mptr->edited) {
			sprintf(string,
			"Can not accept menu - '%s' is required",mptr->name);
			cur_msg_win(string);
			return(0);
		} else if (mptr->type != CUR_MENU_BUTTON &&
				mptr->must_have && *mptr->s_answer == '\0') {
			sprintf(string,"Can not accept menu - '%s' is required",
					mptr->name);
			cur_msg_win(string);
			return(0);
		} else if (mptr->type != CUR_MENU_BUTTON && *mptr->s_answer && 
			!cur_mlist_verify_item(mptr)) {
			{
			return(0);
			}
		}
	}
	if (cur_mverify)
		return cur_mverify(mfirst);
	return 1;
}

#if defined(PROTOTYPES)
int cur_mlist_verify_item(cur_mlist_t *mitem) {
#else
int cur_mlist_verify_item(mitem) cur_mlist_t *mitem; {
#endif
	cur_slist_t	*lptr;
	int		 sign;
	char		*sptr;
	int		 value;
	char		 message[128];

	if (*mitem->s_answer) {
		switch (mitem->type) {
			case CUR_MENU_INT :
				sptr = mitem->s_answer;
				value = 0;
				sign = 1;
				if (*sptr == '-') {
					sign = -1;
					sptr++;
				} else if (*sptr == '+') {
					sign = 1;
					sptr++;
				}
				while (*sptr) {
					if (!isdigit(*sptr)) {
						sprintf(message,"Can not accept - '%s' must be an integer",mitem->name);

						cur_msg_win(message);
#ifdef CURSES
						wclear(cur_mlist_window);
#endif
						return(0);
					}
					value = (value * 10) + *sptr - '0';
					sptr++;
				}
				value *= sign;
				if (mitem->i_lower != mitem->i_upper &&
					(value < mitem->i_lower ||
					value > mitem->i_upper)) {
					sprintf(message,"Can not accept - %s must be an integer between %d and %d",mitem->name,mitem->i_lower,mitem->i_upper);
					cur_msg_win(message);
#ifdef CURSES
					wclear(cur_mlist_window);
#endif
					return(0);
				}
				mitem->i_answer = value;
				break;
			case CUR_MENU_LIST :
				for (lptr = mitem->list,value = 1;
					lptr && cur_casecmp(lptr->string,mitem->s_answer) != 0;
					lptr = lptr->next,value++)
					;
				if (!lptr) {
					sprintf(message,"Can not accept - '%s' must be in list",mitem->name);
					cur_msg_win(message);
#ifdef CURSES
					wclear(cur_mlist_window);
#endif
					return(0);
				}
				mitem->i_answer = value;
				break;
			case CUR_MENU_BOOLEAN :
				if (cur_casecmp(mitem->s_answer,"Yes") == 0 ||
				    cur_casecmp(mitem->s_answer,"Y") == 0 ||
				    cur_casecmp(mitem->s_answer,"True") == 0 ||
				    cur_casecmp(mitem->s_answer,"T") == 0)
					mitem->i_answer = 1;
				else if (cur_casecmp(mitem->s_answer,"No") == 0 ||
				    cur_casecmp(mitem->s_answer,"N") == 0 ||
				    cur_casecmp(mitem->s_answer,"False") == 0 ||
				    cur_casecmp(mitem->s_answer,"F") == 0)
					mitem->i_answer = 0;
				else {
					sprintf(message,"Can not accept - '%s' must answer yes or no",mitem->name);
					cur_msg_win(message);
#ifdef CURSES
					wclear(cur_mlist_window);
#endif
					return(0);
				}
			case CUR_MENU_OTHER :
				return cur_verify(mitem);
		}
	}
	return 1;
}
#if defined(PROTOTYPES)
cur_alist_t *cur_alist_add(cur_alist_t *list, int type,void *data) {
#else
cur_alist_t *cur_alist_add(list,type,data) 
cur_alist_t *list; int type;void *data; {
#endif
	cur_alist_t	*lptr;
	cur_alist_t	*new;

	new = (cur_alist_t *)malloc(sizeof(cur_alist_t));
	new->type = type;
	new->data = data;
	new->next = NULL;
	new->last = NULL;
	if (list) {
		for (lptr = list;lptr->next;lptr = lptr->next)
			;
		lptr->next = new;
		new->last = lptr;
	}
	else
		list = new;
	return(list);
}

#if defined(PROTOTYPES)
void cur_alist_free(cur_alist_t *list) {
#else
void cur_alist_free(list)cur_alist_t *list; {
#endif
	if (list) {
		cur_alist_free(list->next);
		free(list);
	}
}

#if defined(PROTOTYPES)
cur_mlist_t *cur_menu_parse(char *istring) {
#else
cur_mlist_t *cur_menu_parse(istring) char *istring; {
#endif
	int		 max;
	char		*sptr;
	char		*sbegin;
	char		 string[512];
	cur_mlist_t	*mlist;
	int		 upper;
	int		 lower;
	int		 sign;

	strcpy(string,istring);
	mlist = (cur_mlist_t *)malloc(sizeof(cur_mlist_t));
	mlist->name = NULL;
	mlist->type = 0;
	mlist->default_value.value = NULL;
	mlist->have_default = NO;
	mlist->enterable = 1;
	mlist->must_have = 1;
	mlist->s_answer = (char *)malloc(20);
	*mlist->s_answer = '\0';
	mlist->s_answer_size = 20;
	mlist->i_answer = 0;
	mlist->i_lower = 0;
	mlist->i_upper = 0;
	mlist->l_answer = NULL;
	mlist->list = NULL;
	mlist->next = NULL;

/* name */
	sbegin = string;
	for (sptr = string;*sptr && *sptr != ':';sptr++)
	 ;
	if (!*sptr) {
		cur_mlist_free(mlist);
		return(NULL);
	}
	*sptr = '\0';
	mlist->name = cur_mk_str(sbegin);
	*sptr = ':';
/* type */
	sbegin = ++sptr;
	for (;*sptr && *sptr != ':';sptr++)
		;
	if (!*sptr) {
		cur_mlist_free(mlist);
		return(NULL);
	}
	switch (*sbegin) {
		case 'i':
			mlist->type = CUR_MENU_INT;
			break;
		case 's':
			mlist->type = CUR_MENU_STRING;
			break;
		case 'l':
			mlist->type = CUR_MENU_LIST;
			break;
		case 'L':
			mlist->type = CUR_MENU_OLIST;
			break;
		case 'd':
			mlist->type = CUR_MENU_DATA;
			free(mlist->s_answer);
			mlist->s_answer = cur_mdata_file();
			break;
		case 'B':
			mlist->type = CUR_MENU_BOOLEAN;
			break;
		case 'b':
			mlist->type = CUR_MENU_BUTTON;
			break;
		case 'o':
			mlist->type = CUR_MENU_OTHER;
			mlist->type_special = *(sbegin + 1);
			break;
		default:
			cur_mlist_free(mlist);
			return(NULL);
			break;
	}
/* default */
	sbegin = ++sptr;
	for (;*sptr && *sptr != ':';sptr++)
		;
	if (!*sptr) {
		cur_mlist_free(mlist);
		return(NULL);
	}
	if (sbegin != sptr) {
		*sptr = '\0';
		if (mlist->type == CUR_MENU_BOOLEAN) {
			mlist->s_answer_size = 5;
			mlist->s_answer = malloc(5);
			if (cur_casecmp(mlist->s_answer,"Yes") == 0 ||
			    cur_casecmp(mlist->s_answer,"Y") == 0 ||
			    cur_casecmp(mlist->s_answer,"True") == 0 ||
			    cur_casecmp(mlist->s_answer,"T") == 0)
				mlist->default_value.i = 1;
			else
				mlist->default_value.i = atoi(sbegin);
		} else if (mlist->type == CUR_MENU_STRING ||
				mlist->type == CUR_MENU_DATA ||
				mlist->type == CUR_MENU_OTHER)
			mlist->default_value.value = cur_mk_str(sbegin);
		else
			mlist->default_value.i = atoi(sbegin);
		*sptr = ':';
		mlist->have_default = YES;
	}
/* enterable */
	sbegin = ++sptr;
	for (;*sptr && *sptr != ':';sptr++)
		;
	if (!*sptr && (mlist->type == CUR_MENU_LIST ||
			mlist->type == CUR_MENU_OLIST)) {
		cur_mlist_free(mlist);
		return(NULL);
	}
	if (*sbegin == 'u' || *sbegin == 'n')
		mlist->enterable = 0;
/* must_have */
	sbegin = ++sptr;
	for (;*sptr && *sptr != ':';sptr++)
		;
	if (*sbegin == 'n')
		mlist->must_have = 0;
/* list */
	if (mlist->type == CUR_MENU_LIST || mlist->type == CUR_MENU_OLIST) {
		sptr++;
		while (*sptr) {
			max = 0;
			sbegin = sptr;
			for (sptr;*sptr && *sptr != ':';sptr++)
				;
			if (*sptr) {
				*sptr = '\0';
				if (strlen(sbegin) > max)
					max = strlen(sbegin);
				mlist->list = cur_slist_add(mlist->list,
						cur_mk_str(sbegin));
				*sptr = ':';
				sptr++;
			}
			else {
				if (strlen(sbegin) > max)
					max = strlen(sbegin);
				mlist->list = cur_slist_add(mlist->list,
						cur_mk_str(sbegin));
			}
		}
		free(mlist->s_answer);
		mlist->s_answer = (char *)malloc(max + 10);
		mlist->s_answer_size = max + 10;
		if (!mlist->list) {
			cur_mlist_free(mlist);
			return(NULL);
		}
	} else if (mlist->type == CUR_MENU_INT) {
		sptr++;
		upper = 0;
		lower = 0;
		if (*sptr == '-') {
			sign = -1;
			sptr++;
		} else 
			sign = 1;
		sbegin = sptr;
		for (;isdigit(*sptr);sptr++)
			;
		if (isdigit(*sbegin) && *sptr == ':') {
			*sptr = '\0';
			lower = sign * atoi(sbegin);
			*sptr = ':';
			sptr++;
			if (*sptr == '-') {
				sign = -1;
				sptr++;
			} else 
				sign = 1;
			sbegin = sptr;
			for (;isdigit(*sptr);sptr++)
				;
			if (isdigit(*sbegin) && !*sptr) {
				upper = sign * atoi(sbegin);
				if (upper > lower) {
					mlist->i_lower = lower;
					mlist->i_upper = upper;
				}
			}
		}
	}
	return(mlist);
}

/*
cur_menu_reset.c - Reset mlist 'menu' to the default values.
*/

#if defined(PROTOTYPES)
void cur_menu_reset(cur_mlist_t *menu) {
#else
void cur_menu_reset(menu) cur_mlist_t *menu; {
#endif
	int		 loop;
	cur_mlist_t	*mptr;
	int		 slen;
	char		 string[25];

	for (mptr = menu;mptr;mptr = mptr->next) {
		mptr->edited = NO;
		if (mptr->have_default) {
			switch (mptr->type) {
				case CUR_MENU_INT:
					mptr->i_answer = mptr->default_value.i;
					sprintf(mptr->s_answer,"%d",
							mptr->default_value.i);
					break;
				case CUR_MENU_BOOLEAN:
					mptr->i_answer = mptr->default_value.i;
					if (mptr->i_answer) 
						strcpy(mptr->s_answer,"Yes");
					else
						strcpy(mptr->s_answer,"No");
					break;
				case CUR_MENU_STRING:
				case CUR_MENU_OTHER:
					slen = strlen(mptr->default_value.value)
							+ 1;
					if (slen >= mptr->s_answer_size) {
						mptr->s_answer = realloc(
						    mptr->s_answer,slen);
						mptr->s_answer_size = slen;
					}
					strcpy(mptr->s_answer,
						    mptr->default_value.value);
					break;
				case CUR_MENU_LIST:
				case CUR_MENU_OLIST:
					mptr->i_answer = mptr->default_value.i;
					for (loop=1,mptr->l_answer = mptr->list;
						loop < mptr->i_answer;
						loop++,mptr->l_answer =
						    mptr->l_answer->next)
						 ;
					slen = strlen(mptr->l_answer->string) + 1;
					if (slen >= mptr->s_answer_size) {
						mptr->s_answer = realloc(
							mptr->s_answer,slen);
						mptr->s_answer_size = slen;
					}
					strcpy(mptr->s_answer,
						mptr->l_answer->string);
					break;
				case CUR_MENU_DATA:
					if (!*mptr->s_answer ||
							!mptr->s_answer_size) {
						mptr->s_answer=cur_mdata_file();
						mptr->s_answer_size = 20;
						mptr->i_answer = 20;
					}
					unlink(mptr->s_answer);
					break;
			}
		} else {
			if (*mptr->s_answer && mptr->type != CUR_MENU_DATA) {
				if (mptr->type != CUR_MENU_DATA)
					*mptr->s_answer = '\0';
				else {
					unlink(mptr->s_answer);
					mptr->i_answer = 0;
				}
			}
			else if (mptr->type == CUR_MENU_DATA) {
				if (!*mptr->s_answer || ! mptr->s_answer_size) {
					mptr->s_answer = cur_mdata_file();
					mptr->s_answer_size = 20;
					mptr->i_answer = 20;
				}
				unlink(mptr->s_answer);
			}
		}
	}
	return;
}

/*
cur_mk_str.c - Allocate and duplication a copy of the string
*/

#if defined(PROTOTYPES)
char *cur_mk_str(char *string) {
#else
char *cur_mk_str(string) char *string; {
#endif
	char *ret;

	if (!string)
		return(NULL);
	ret = malloc(strlen(string) + 1);
	strcpy(ret,string);
	return(ret);
}

/*
cur_mlist_add.c - Add mlist item 'mlist2' to the end of 'mlist'
*/


#if defined(PROTOTYPES)
cur_mlist_t *cur_mlist_add(cur_mlist_t *list1,cur_mlist_t *list2) {
#else
cur_mlist_t *cur_mlist_add(list1,list2) cur_mlist_t *list1;cur_mlist_t *list2; {
#endif
	cur_mlist_t	*lptr;

	if (!list2)
		return list1;
	if (list1) {
		for (lptr = list1;lptr->next;lptr = lptr->next)
			;
		lptr->next = list2;
		list2->last = lptr;
	}
	else {
		list1 = list2;
		list2->last = NULL;
	}
	return(list1);
}

/*
cur_mlist_free.c - Free the menu 'mlist' and its contents.
*/

#if defined(PROTOTYPES)
void cur_mlist_free(cur_mlist_t *mlist) {
#else
void cur_mlist_free(mlist) cur_mlist_t *mlist; {
#endif
	cur_mlist_t *next;
	cur_slist_t *snext;
	cur_slist_t *sptr;

	while (mlist) {
		next = mlist->next;
		if (mlist->name)
			free(mlist->name);
		if ((mlist->type == CUR_MENU_STRING ||
				mlist->type == CUR_MENU_DATA ||
				mlist->type == CUR_MENU_OTHER) &&
				mlist->default_value.value)
			free(mlist->default_value.value);
		for (sptr = mlist->list,snext = sptr->next;sptr;
				sptr = snext,snext = sptr->next)
			free(sptr);
		free(mlist);
		mlist = next;
	}
}

/*
cur_mlist_set.c - Set the mlist item 'item' to either the value of 'svalue' or
				'ivalue' depending on 'item' type.
*/

#if defined(PROTOTYPES)
void cur_mlist_set(cur_mlist_t *item,char *svalue,int ivalue) {
#else
void cur_mlist_set(item,svalue,ivalue) 
cur_mlist_t *item;char *svalue;int ivalue; {
#endif
	int loop;
	int slen;

	switch(item->type) {
		case CUR_MENU_INT:
			item->i_answer = ivalue;
			sprintf(item->s_answer,"%d",ivalue);
			break;
		case CUR_MENU_BOOLEAN:
			if (cur_casecmp(svalue,"Yes") == 0 ||
			    cur_casecmp(svalue,"Y") == 0 ||
			    cur_casecmp(svalue,"True") == 0 ||
			    cur_casecmp(svalue,"T") == 0) {
				item->default_value.i = 1;
				item->s_answer = "Yes";
			} else {
				item->default_value.i = atoi(svalue);
				item->s_answer = "No";
			}
			break;
		case CUR_MENU_STRING:
		case CUR_MENU_OTHER:
			if (svalue) {
				slen = strlen(svalue) + 1;
				if (slen >= item->s_answer_size) {
					item->s_answer = realloc(item->s_answer,
							slen);
					item->s_answer_size = slen;
				}
				strcpy(item->s_answer,svalue);
			}
			else
				*item->s_answer = '\0';
			break;
		case CUR_MENU_LIST:
		case CUR_MENU_OLIST :
			if (svalue) {
				slen = strlen(svalue) + 1;
				if (slen >= item->s_answer_size) {
					item->s_answer = realloc(item->s_answer,
							slen);
					item->s_answer_size = slen;
				}
				strcpy(item->s_answer,svalue);
				for (loop = 1,item->l_answer = item->list;
						 item->l_answer &&
						 strcmp(item->l_answer->string,
						     svalue) != 0;
						 loop++,
						 item->l_answer =
						     item->l_answer->next)
					;
				if (item->l_answer)
					item->i_answer = loop;
				else
					item->i_answer = 0;
			}
			else {
				item->i_answer = ivalue;
				for (loop = 1,item->l_answer = item->list;
						loop < item->i_answer;
						loop++,item->l_answer =
						    item->l_answer->next)
					;
				slen = strlen(item->l_answer->string) + 1;
				if (slen >= item->s_answer_size) {
					item->s_answer = realloc(item->s_answer,
							slen);
					item->s_answer_size = slen;
				}
				strcpy(item->s_answer,item->l_answer->string);
			}
			break;
	}
}

#if defined(PROTOTYPES)
cur_slist_t *cur_slist_add(cur_slist_t *list, char *string) {
#else
cur_slist_t *cur_slist_add(list,string) cur_slist_t *list; char *string; {
#endif
	cur_slist_t *lptr;
	cur_slist_t *new;

	new = (cur_slist_t *)malloc(sizeof(cur_slist_t));
	new->string = string;
	new->next = NULL;
	new->last = NULL;
	if (list) {
		for (lptr = list;lptr->next;lptr = lptr->next)
			;
		lptr->next = new;
		new->last = lptr;
	}
	else
		list = new;
	return(list);
}


#if defined(PROTOTYPES)
void cur_slist_free(cur_slist_t *list) {
#else
void cur_slist_free(list) cur_slist_t *list; {
#endif
	if (list) {
		if (list->string)
			free(list->string);
		cur_slist_free(list->next);
		free(list);
	}
}

#if defined(PROTOTYPES)
char *cur_mdata_file(void) {
#else
char *cur_mdata_file() {
#endif
	char f1[40];
	char *f2;
	static count = 0;
#if !defined(HITM) && !defined(SUN)
	extern char *mktemp();
#endif

	sprintf(f1,"/tmp/cur.%d.XXXXXX",count++);
#if defined(HITM) || defined(SUN)
	mktemp(f1);
	return(cur_mk_str(f1));
#else
	f2 = mktemp(f1);
	return(cur_mk_str(f2));
#endif
}

#if defined(PROTOTYPES)
int cur_casecmp(char *s1,char *s2) {
#else
int cur_casecmp(s1,s2) char *s1;char *s2; {
#endif
	while (*s1 && *s2 && !(tolower(*s1) - tolower(*s2))) {
		s1++;
		s2++;
	}
	return(*s1 - *s2);
}

/*
cur_error.c - Display an error using a curses box if cur is started, otherwise
				dump it to stderr
*/

#if defined(PROTOTYPES)
void cur_error(char *string) {
#else
void cur_error(string) char *string; {
#endif
	if (cur_started)
		cur_msg_win(string);
	else
		fprintf(stderr,"%s\n",string);
}
