static char version[] =
"hcal version 1.0 - postscript hebrew calendar generator\n\n\
copyright 1994,1995 - Steven Weintraub";

/*
 
    hcal version 1.0 - postscript hebrew calendar generator
    copyright 1994,1995 - Steven Weintraub
 
    This program is created and distribed by Steven Weintraub. It
    can be freely distributed without permission as long as this
    head is retained in all files it appears and the LICENCE file
    accompanies it.
 
*/

#include "cur.h"
#include <ctype.h>

int	cur_lines	= 25;
int	cur_started	= NO;

#if defined(PROTOTYPES)
void		cur_start(int d1,char **d2)
#else
void		cur_start(d1,d2)
int d1;char **d2;
#endif
{
	cur_started = YES;
	return;
}

#if defined(PROTOTYPES)
void		cur_stop(void)
#else
void		cur_stop()
#endif
{
	cur_started = NO;
	return;
}

#if defined(PROTOTYPES)
void		cur_getline(char *line,int max)
#else
void		cur_getline(line,max)
char *line;int max;
#endif
{
	int	 ch;
	char	*lptr;

	lptr = line;
	max--;
	printf("> ");
	while (ch = getchar(),ch != EOF && ch != '\n') {
		if (max > 0) {
			max--;
			*lptr = ch;
			lptr++;
		}
	}
	*lptr = '\0';
	if (ch == EOF)
		clearerr(stdin);
	return;
}

#if defined(PROTOTYPES)
void cur_msg_win(char *message)
#else
void cur_msg_win(message)
char *message;
#endif
{
	char	 line[MAX_STR];

	printf("%c%s (<cr> to continue) ",7,message);
	cur_getline(line,MAX_STR);
}

#if defined(PROTOTYPES)
int cur_ask_y_n(char *string1,char *string2) {
#else
int cur_ask_y_n(string1,string2) char *string1;char *string2; {
#endif
	int	 more;
	int	 length;
	char	 line[MAX_STR];

	printf("%s?\n",string1);
	cur_getline(line,MAX_STR);
	if (isupper(*line))
		*line = tolower(*line);
	while (*line != 'y' && *line != 'n') {
		printf("Please answer 'y' or 'n'.  %s?\n",string2);
		cur_getline(line,MAX_STR);
		if (isupper(*line))
			*line = tolower(*line);
	}
	if (*line == 'n')
		return(0);
	return(1);
}

#if defined(PROTOTYPES)
int cur_ask_num_lud(char *string1, char *string2, int lower, int upper,
		int default_v) {
#else
int cur_ask_num_lud(string1,string2,lower,upper,default_v)
char *string1; char *string2; int lower; int upper; int default_v; {
#endif
	char	 line[MAX_STR];
	char	*lptr;
	int	 more;
	int	 number;

	printf("%s (%d)?\n",string1,default_v);
	more = YES;
	while (more) {
		cur_getline(line,MAX_STR);
		if (*line) {
			number = 0;
			for (lptr = line;*lptr && isdigit(*lptr);lptr++) {
				number = number * 10 + *lptr - '0';
			}
			if (*lptr || number < lower || number > upper) {
				printf("Please enter number between %d and %d. %s (%d)?\n",
				lower,upper,string2,default_v);
			} else {
				more = NO;
			}
		} else {
			more = NO;
			number = default_v;
		}
	}
	return(number);
}

#if defined(PROTOTYPES)
char *cur_strd(char *question, char *default_value, char *answer) {
#else
char *cur_strd(question, default_value, answer) 
char *question; char *default_value; char *answer; {
#endif
	char	 line[MAX_STR];

	printf("%s (%s)?\n",question,default_value);
	cur_getline(line,MAX_STR);
	if (*line)
		strcpy(answer,line);
	else
		strcpy(answer,default_value);
	return(answer);
}

#if defined(PROTOTYPES)
void cur_text_dsp(char **strings)
#else
void cur_text_dsp(strings) char **strings; 
#endif
{
	int       count;
	int       ch;
	char    **sptr;

	for (sptr = strings,count = 0;*sptr;sptr++,count++) {
		printf("%s\n",*sptr);
		if (count > cur_lines - 2) {
			count = 0;
			printf("\nHit <cr> for more");
			while (ch = getchar(),ch != EOF && ch != '\n')
				;
			putchar('\n');
		}
	}
	if (count)
		printf("\nHit <cr> to continue");
	while (ch = getchar(),ch != EOF && ch != '\n')
		;
	putchar('\n');
}

#if defined(PROTOTYPES)
cur_slist_t *cur_slist_fancy(char *title,cur_slist_t *list,int current,int *chosen)
#else
cur_slist_t *cur_slist_fancy(title,list,current,chosen)
char *title;cur_slist_t *list;int current; int *chosen;
#endif
{
	int		 items;
	char	 	 line[MAX_STR];
	int		 lines;
	char		*liptr;
	int		 loop;
	cur_slist_t	*lptr;
	int		 more;
	int		 number;
	int		 place;
	int		 redo_place;
	cur_slist_t	*redo_lptr;

	for (lptr = list,items = 0;lptr;items++,lptr = lptr->next)
		;
	lptr = list;
	place = 1;
	more = YES;
	lines = cur_lines - 5;
	while (more) {
		redo_place = place;
		redo_lptr = lptr;
		printf("%s\n\n",title);	
		for (loop = 0;lptr && loop < lines;
				loop++,place++,lptr = lptr->next) {
			printf("%2d) %s\n",place,lptr->string);
		}
		printf("\nType selection number");
		if (items > lines) {
			if (lptr) {
				printf(", or <cr> to continue list");
			} else {
				printf(", or <cr> to restart list");
			}
		}
		putchar('\n');
		cur_getline(line,MAX_STR);
		if (*line) {
			number = 0;
			for (liptr = line;*liptr && isdigit(*liptr);liptr++)
				number = number * 10 + *liptr - '0';
			if (*liptr || number < 1 || number > items) {
				place = redo_place;
				lptr = redo_lptr;
				sprintf(line,"Please enter number between 1 and %d.",items);
				cur_msg_win(line);
			} else
				more = NO;
		}
		if (!lptr) {
			place = 1;
			lptr = list;
		}
	}
	for (lptr = list,items = 1;items < number;items++,lptr = lptr->next)
		;
	*chosen = number;
	return(lptr);
}

#if defined(PROTOTYPES)
int cur_alist_ask(char *title,cur_alist_t *list,int current,char *actions,
		int action(int,int,void *),
		char *print(int,void *,char *))
#else
int cur_alist_ask(title,list,current,actions,action,print) 
char *title; cur_alist_t *list;int current;char *actions;
int (*action)();char *(*print)();
#endif
{
	int		 count;
	int		 items;
	char	 	 line[MAX_STR];
	int		 lines;
	char		*liptr;
	int		 loop;
	cur_alist_t	*lptr;
	cur_alist_t	*lptr2;
	int		 number;
	int		 place;
	cur_alist_t	*redo_lptr;
	int		 redo_place;
	int		 status;

	for (lptr = list,items = 0;lptr;items++,lptr = lptr->next)
		;
	lines = cur_lines - 5;
	number = (((current - 1) / lines) * lines) + 1;
	for (lptr = list,place = 1;place < number;place++,lptr = lptr->next)
		;
	status = CUR_ALIST_CONTINUE;
	number = current;
	while (status == CUR_ALIST_CONTINUE || status == CUR_ALIST_REDRAW) {
		redo_place = place;
		redo_lptr = lptr;
		printf("%s\n\n",title);	
		for (loop = 0;lptr && loop < lines;
				loop++,place++,lptr = lptr->next) {
			printf("%2d) %s\n",place,
					print(lptr->type,lptr->data,line));
		}
		printf("\nType ");
		if (actions) 
			printf("one of '%s', ",actions);
		if (items > lines) {
			if (lptr) {
				printf("selection number, or <cr> to continue list");
			} else {
				printf("selection number, or <cr> to restart list");
			}
		} else {
			printf("or selection number");
		}
		putchar('\n');
		cur_getline(line,MAX_STR);
		if (*line) {
			place = redo_place;
			lptr = redo_lptr;
			if (isdigit(*line)) {
				number = 0;
				place = redo_place;
				lptr = redo_lptr;
				for (liptr = line;*liptr && isdigit(*liptr);
						liptr++)
					number = number * 10 + *liptr - '0';
				if (*liptr || number < 1 || number > items) {
					sprintf(line,"Please enter number between 1 and %d.",items);
					cur_msg_win(line);
				} else {
					for (lptr2 = list,count = 1;
							count < number;
							count++,
							lptr2 = lptr2->next)
						;
					status = action(' ',lptr2->type,
							lptr2->data);
				}
			} else if (actions && strchr(actions,*line) && 
					!*(line + 1)) {
				status = action(*line,0,NULL);
			} else {
				cur_msg_win("Invalid response");
			}
		}
		if (!lptr) {
			place = 1;
			lptr = list;
		}
	}
	return(number);
}

#if defined(PROTOTYPES)
int cur_menu_ask(char*title,cur_mlist_t *menu,int cur_mverify(cur_mlist_t *))
#else
int cur_menu_ask(title,menu,cur_mverify)
char* title;cur_mlist_t *menu;int (*cur_mverify)();
#endif
{
	int		 choose;
	int		 count;
	int		 items;
	char		 line[MAX_STR];
	int		 lines;
	char		*liptr;
	int		 loop;
	int		 more;
	cur_mlist_t	*mptr;
	cur_mlist_t	*mptr2;
	int		 number;
	int		 place;
	cur_mlist_t	*redo_mptr;
	int		 redo_place;
	int		 retval;
	char		 save[MAX_STR];
	cur_slist_t	*sitem;
	int		 type;

	for (mptr = menu,items = 0;mptr;items++,mptr = mptr->next)
		;
	mptr = menu;
	place = 1;
	more = YES;
	lines = cur_lines - 5;
	while (more) {
		redo_place = place;
		redo_mptr = mptr;
		printf("%s\n\n",title);	
		for (loop = 0;mptr && loop < lines;
				loop++,place++,mptr = mptr->next) {
			printf("%2d) %s : %s\n",place,mptr->name,
					mptr->s_answer);
		}
		printf("\nType 'accept', 'cancel', ");
		if (items > lines) {
			if (mptr) {
				printf(", selection number or to change <cr> to continue list\n");
			} else {
				printf(", selection number to change or <cr> to restart list\n");
			}
		}
		else
			printf(" or selection number to change\n");
		putchar('\n');
		cur_getline(line,MAX_STR);
		if (*line) {
			place = redo_place;
			mptr = redo_mptr;
			if (isdigit(*line)) {
				number = 0;
				for (liptr = line;*liptr && isdigit(*liptr);
						liptr++)
					number = number * 10 + *liptr - '0';
				if (*liptr || number < 1 || number > items) {
					place = redo_place;
					mptr = redo_mptr;
					sprintf(line,"Please enter number between 1 and %d.",items);
					cur_msg_win(line);
				} else {
					for (mptr2 = menu,count = 1;
							count < number;
							count++,
							mptr2 = mptr2->next)
						;
if (mptr2->enterable) {
	if (mptr2->type == CUR_MENU_LIST || mptr2->type == CUR_MENU_OLIST)
		printf("Enter New value for %s - or '?' for list selection\n",
			mptr2->name);
	else
		printf("Enter New value for %s :\n",
			mptr2->name);
	cur_getline(line,MAX_STR);
	if ((mptr2->type == CUR_MENU_LIST || mptr2->type == CUR_MENU_OLIST)
			&& *line == '?') {
		sitem = cur_slist_fancy("Select One",mptr2->list,1,&choose);
		strcpy(line,sitem->string);
	}
	strcpy(save,mptr2->s_answer);
	type = mptr2->type;
	mptr2->type = CUR_MENU_STRING;
	cur_mlist_set(mptr2,line,0);
	mptr2->type = type;
	if (!cur_mlist_verify_item(mptr2))
		strcpy(mptr2->s_answer,save);
} else {
	cur_msg_win("Item is not editable");
}
				}
			} else if (cur_casecmp("c",line) == 0 || 
					cur_casecmp("cancel",line) == 0) {
				more = NO;
				retval = NO;
			} else if (cur_casecmp("a",line) == 0 || 
					cur_casecmp("accept",line) == 0) {
				more = NO;
				retval = YES;
			} else {
				cur_msg_win("Illegal Input");
			}
		}
		if (!mptr) {
			place = 1;
			mptr = menu;
		}
		if (!more && retval && !cur_mlist_verify_all(menu)) {
			more = YES;
		}
	}
	return(retval);
}
