static char version[] =
"hcal version 1.0 - postscript hebrew calendar generator\n\n\
copyright 1994,1995 - Steven Weintraub";

/*
 
    hcal version 1.0 - postscript hebrew calendar generator
    copyright 1994,1995 - Steven Weintraub
 
    This program is modified and distribed by Steven Weintraub.	 It
    can be freely distributed without permission as long as this
    head is retained in all files it appears and the LICENCE file
    accompanies it.
 
*/

#include "hcal.h"
#include "hebcal.h"

  /* hebcal.c main module for hebrew calendar program
     By Danny Sadinoff
     (C) 1993

     $Date: 93/09/26 16:26:59 $
     $Revision:	2.1 $

     */

  static int chanukah, omer;

static holstorep_t holidays[13][MAXDAYS],union_Adar[MAXDAYS];

static year_t legend[2][8] = {
  {				/* stam years */
    {"1BX",353,29,29,1,1,1,1,0,1,1},	/* BX */
    {"1BS",355,30,30,1,1,1,1,1,1,1},	/* BS */
    {"2GC",354,29,30,1,1,1,1,1,1,1},	/* GC */
    {"4HC",354,29,30,1,1,1,1,0,1,0},	/* HC */
    {"0error - HX",354,29,29,1,1,1,1,0,1,0},	/* error! hx */
    {"4HS",355,30,30,0,1,1,1,0,1,0},	/* HS */
    {"6ZX",353,29,29,1,1,1,1,0,1,0},	/* ZX */
    {"6ZS",355,30,30,1,1,1,1,0,1,1},	/* ZS */
  },
  {				/* leap years */
    {"1BX",383,29,29,0,0,0,0,1,1,1},	/* BX */
    {"1BS",385,30,30,0,0,0,0,0,1,0},	/* BS */
    {"2GC",384,29,30,0,0,0,0,0,1,0},	/* GC */
    {"0error - HC",383,29,30,0,0,0,0,0,0,0},	/* error ! hc */
    {"4HX",383,29,29,0,0,0,0,0,0,0},	/* HX */
    {"4HS",385,30,30,0,0,0,0,0,0,1},	/* HS */
    {"6ZX",383,29,29,0,0,0,0,0,1,1},	/* ZX */
    {"6ZS",385,30,30,0,0,0,0,1,1,1},	/* ZS */
  }
};

static int leapYears[] = {0,0,1,0,0,1,0,1,0,0,1,0,0,1,0,0,1,0,1};
/*enum {BX,BS,GC,HC,HX,HS,ZX,ZS}; */
#define BX 0
#define BS 1
#define GC 2
#define HC 3
#define HX 4
#define HS 5
#define ZX 6
#define ZS 7

static int luach[][19] =
{
  {HC,BX,HS,HC,BS,ZX,HC,BS,BX,HS,GC,BS,ZX,GC,BS,ZS,HX,GC,ZS},
  {ZS,HC,BX,ZS,HC,BX,ZS,HS,HC,BX,HS,HC,BS,ZX,HC,BS,ZX,HS,GC},
  {BS,ZX,GC,BS,ZS,HX,GC,ZS,ZS,HC,BX,ZS,HC,BS,BX,HC,BS,BS,ZX},
  {HC,HS,ZX,HC,HS,ZS,ZX,GC,BS,ZS,HX,GC,ZS,HS,HC,BX,HS,HC,BX},
  {ZS,HC,BS,BX,HC,BS,BS,ZX,HC,BS,ZX,HS,GC,ZS,ZS,HC,BX,ZS,HX},
  {GC,ZS,HS,HC,BX,HS,HC,BX,ZS,HC,BS,BX,HS,GC,BS,ZX,GC,BS,ZS},
  {ZX,GC,ZS,ZS,HC,BX,ZS,HX,GC,ZS,HS,HC,BX,HS,HC,BS,ZX,HC,BS},
  {BS,ZX,GC,BS,ZS,HX,GC,ZS,ZX,GC,ZS,ZS,HC,BX,ZS,HC,BS,BX,HS},
  {HC,BS,ZX,HC,BS,ZX,HS,GC,BS,ZX,GC,BS,ZS,HX,GC,ZS,HS,HC,BX},
  {ZS,HC,BX,ZS,HC,BS,BX,HS,HC,BS,ZX,HC,BS,ZX,HS,GC,ZS,ZX,GC},
  {BS,ZS,HX,GC,ZS,HS,HC,BX,ZS,HC,BX,ZS,HC,BS,BX,HS,GC,BS,ZX}, /* 10,11 GX? */
  {HC,BS,ZS,ZX,GC,ZS,ZS,HX,GC,ZS,HX,GC,ZS,HS,HC,BX,HS,HC,BS},
  {BX,HC,BS,BS,ZX,GC,BS,ZX,HS,GC,ZS,ZS,HC,BX,ZS,HC,BX,ZS,HS}
};

static struct {
  char * name;
  int length;
}hMonths[][14] = {
  {
    {"Tishrei",30}, {"Cheshvan",29}, {"Kislev",30},
    {"Tevet",29}, {"Sh'vat",30}, {"Adar",29},
    {"Nisan",30}, {"Iyyar",29}, {"Sivan",30},
    {"Tamuz",29}, {"Av",30},{"Elul",29},{"Tishrei",30}},
  {
    {"Tishrei",30}, {"Cheshvan",29}, {"Kislev",30},
    {"Tevet",29}, {"Sh'vat",30}, {"Adar I",30}, {"Adar II",29},
    {"Nisan",30}, {"Iyyar",29}, {"Sivan",30},
    {"Tamuz",29}, {"Av",30},{"Elul",29},{"Tishrei",30}}
};

#define TISHREI 0
#define CHESHVAN 1
#define KISLEV 2
#define ADAR_2 6

#define LANGUAGE(str) (flag_a && (str)[1] ? ((str)[1]) : ((str)[0]))

#define SEPHARDIC_NAME	  0
#define ASHKENAZI_NAME	  1
#define TORAH_READING	  2
#define TWO_TORAH_READING 3
#define ASHKENAZI_PROPHET 4
#define SEPHARDIC_PROPHET 5

static char * sedrot[][6] = {
/* SEPHARDIC_NAME        ASHKENAZI_NAME        TORAH_READING       TWO_TORAH_READING   ASHKENAZI_PROPHET         SEPHARDIC_PROPHET*/
  {"Bereshit",           "Bereshis",           "Gen. 1:1-6:8",     "Gen. 1:1-6:8",     "Is. 42:5-43:10",         "Is 42:5-21"},
  {"Noach",              "Noach",              "Gen. 6:9-11:32",   "Gen. 6:9-11:32",   "Is. 54:1-55:5",          "Is. 54:1-54:10"},
  {"Lech-Lecha",         "Lech-Lecha",         "Gen. 12:1-17:27",  "Gen. 12:1-17:27",  "Is. 40:27-41:16",        "Is. 40:27-41:16"},
  {"Vayera",             "Vayera",             "Gen. 18:1-22:24",  "Gen. 18:1-22:24",  "II Kings 4:1-37",        "II Kings 4:1-23"},
  {"Chayei Sara",        "Chayei Sara",        "Gen. 23:1-25:18",  "Gen. 23:1-25:18",  "I Kings 1:1-31",         "I Kings 1:1-31"},
  {"Toldot",             "Toldos",             "Gen. 25:19-28:9",  "Gen. 25:19-28:9",  "Mal. 1:1-2:7",           "Mal. 1:1-2:7"},
  {"Vayetzei",           "Vayetzei",           "Gen. 28:10-32:3",  "Gen. 28:10-32:3",  "Hos. 12:13-14:10",       "Hos. 11:7-12:12"},
  {"Vayishlach",         "Vayishlach",         "Gen. 32:4-36:43",  "Gen. 32:4-36:43",  "Hos. 11:7-12:12",        "Ob. 1:1-21"},
  {"Vayeshev",           "Vayeshev",           "Gen. 37:1-40:23",  "Gen. 37:1-40:23",  "Amos 2:6-3:8",           "Amos 2:6-3:8"},
  {"Miketz",             "Miketz",             "Gen. 41:1-44:17",  "Gen. 41:1-44:17",  "I Kings 3:15-4:1",       "I Kings 3:15-4:1"},
  {"Vayigash",           "Vayigash",           "Gen. 44:18-47:27", "Gen. 44:18-47:27", "Ez. 37:15-28",           "Ez. 37:15-28"},
  {"Vayechi",            "Vayechi",            "Gen. 47:28-50:26", "Gen. 47:28-50:26", "I Kings 2:1-12",         "I Kings 2:1-12"},
  {"Shemot",             "Shemos",             "Ex. 1:1-6:1",      "Ex. 1:1-6:1",      "Is. 27:6-28:13,29:22-23","Jer. 1:1-2:3"},
  {"Vaera",              "Vaera",              "Ex. 6:2-9:35",     "Ex. 6:2-9:35",     "Ez. 28:25-29:21",        "Ez. 28:25-29:21"},
  {"Bo",                 "Bo",                 "Ex. 10:1-13:16",   "Ex. 10:1-13:16",   "Jer. 46:13-28",          "Jer. 46:13-28"},
  {"Beshalach/Shirah",   "Beshalach/Shirah",   "Ex. 13:17-17:16",  "Ex. 13:17-17:16",  "Jud. 4:4-5:31",          "Jud. 5:1-31"},
  {"Yitro",              "Yisro",              "Ex. 18:1-20:23",   "Ex. 18:1-20:23",   "Is. 6:1-7:6,9:5-6",      "Is. 6:1-13"},
  {"Mishpatim",          "Mishpatim",          "Ex. 21-1:24:18",   "Ex. 21-1:24:18",   "Jer. 34:8-22,33:25-26",  "Jer. 34:8-22,33:25-26"},
  {"Terumah",            "Terumah",            "Ex. 25:1-27:19",   "Ex. 25:1-27:19",   "I Kings 5:26-6:13",      "I Kings 5:26-6:13"},
  {"Tetzaveh",           "Tetzaveh",           "Ex. 27:20-30:10",  "Ex. 27:20-30:10",  "Ez. 43:10-27",           "Ez. 43:10-27"},
  {"Ki Tisa",            "Ki Sisa",            "Ex. 30:11-34:35",  "Ex. 30:11-34:35",  "I Kings 18:1-39",        "I Kings 18:20-39"},
  {"Vayakhel",           "Vayakhel",           "Ex. 35:1-38:20",   "Ex. 35:1-40:38",   "I Kings 7:40-50",        "I Kings 7:13-26"},
  {"Pekudei",            "Pekudei",            "Ex. 38:21-40:38",  "Ex. 35:1-40:38",   "I Kings 7:51-8:21",      "I Kings 7:40-50"},
  {"Vayikra",            "Vayikra",            "Lev. 1:1-5:26",    "Lev. 1:1-5:26",    "Is. 43:21-44:23",        "Is. 43:21-44:23"},
  {"Tzav",               "Tzav",               "Lev. 6:1-8:36",    "Lev. 6:1-8:36",    "Jer. 7:21-8:3,9:22-23",  "Jer. 7:21-8:3,9:22-23"},
  {"Shmini",             "Shmini",             "Lev. 9:1-11:47",   "Lev. 9:1-11:47",   "II Sam. 6:1-7:17",       "II Sam. 6:1-19"},
  {"Tazria",             "Sazria",             "Lev. 12:1-13:59",  "Lev. 12:1-15:33",  "II Kings 4:42-5:19",     "II Kings 4:42-5:19"},
  {"Metzora",            "Metzora",            "Lev. 14:1-15:33",  "Lev. 12:1-15:33",  "II Kings 7:3-20",        "II Kings 7:3-20"},
  {"Achrei Mot",         "Achrei Mos",         "Lev. 16:1-18:30",  "Lev. 16:1-20:27",  "Ez. 22:1-19",            "Ez. 22:1-16"},
  {"Kedoshim",           "Kedoshim",           "Lev. 19:1-20:27",  "Lev. 16:1-20:27",  "Amos 9:7-15",            "Ez. 20:2-20"},
  {"Emor",               "Emor",               "Lev. 21:1-24:23",  "Lev. 21:1-24:23",  "Ez. 44:15-31",           "Ez. 44:15-31"},
  {"Behar",              "Behar",              "Lev. 25:1-26:2",   "Lev. 25:1-27:34",  "Jer. 32:6-27",           "Jer. 32:6-27"},
  {"Bechukotai",         "Bechukosai",         "Lev. 26:3-27:34",  "Lev. 25:1-27:34",  "Jer 16:19-17:14",        "Jer 16:19-17:14"},
  {"Bamidbar",           "Bamidbar",           "Num. 1:1-4:20",    "Num. 1:1-4:20",    "Hos. 2:1-22",            "Hos. 2:1-22"},
  {"Nasso",              "Nasso",              "Num. 4:21-7:89",   "Num. 4:21-7:89",   "Jud. 13:2-25",           "Zech. 2:14-4:7"},
  {"Beha'alotcha",       "Beha'aloscha",       "Num. 8:1-12:16",   "Num. 8:1-12:16",   "Zech. 2:14-4:7",         "Zech. 2:14-4:7"},
  {"Sh'lach",            "Sh'lach",            "Num. 13:1-15:41",  "Num. 13:1-15:41",  "Jos. 2:1-24",            "Jos. 2:1-24"},
  {"Korach",             "Korach",             "Num. 16:1-18:32",  "Num. 16:1-18:32",  "I Sam. 11:14-12:22",     "I Sam. 11:14-12:22"},
  {"Chukat",             "Chukas",             "Num. 19:1-22:1",   "Num. 19:1-25:9",   "Jud. 11:1-33",           "Jud. 11:1-33"},
  {"Balak",              "Balak",              "Num. 22:2-25:9",   "Num. 19:1-25:9",   "Mic. 5:6-6:8",           "Mic. 5:6-6:8"},
  {"Pinchas",            "Pinchas",            "Num. 25:10-30:1",  "Num. 25:10-30:1",  "I Kings 18:46-19:21",    "I Kings 18:46-19:21"},
  {"Matot",              "Matos",              "Num. 30:2-32:42",  "Num. 30:2-36:13",  "Jer 1:1-2:3",            "Jer 1:1-2:3"},
  {"Masei",              "Masei",              "Num. 33:1-36:13",  "Num. 30:2-36:13",  "Jer. 2:4-28,3:4",        "Jer. 2:4-28,4:1-2"},
  {"Devarim/Chazon",     "Devarim/Chazon",     "Deut. 1:1-3:22",   "Deut. 1:1-3:22",   "Is. 1:1-27",             "Is. 1:1-27"},
  {"Vaetchanan/Nachmanu","Vaeschanan/Nachmanu","Deut. 3:23-7:11",  "Deut. 3:23-7:11",  "Is. 40:1-26",            "Is. 40:1-26"},
  {"Eikev",              "Eikev",              "Deut. 7:12-11:25", "Deut. 7:12-11:25", "Is. 49:14-51:3",         "Is. 49:14-51:3"},
  {"Re'eh",              "Re'eh",              "Deut. 11:26-16:17","Deut. 11:26-16:17","Is. 54:11-55:5",         "Is. 54:11-55:5"},
  {"Shoftim",            "Shoftim",            "Deut. 16:18-21:9", "Deut. 16:18-21:9", "Is. 51:12-52:12",        "Is. 51:12-52:12"},
  {"Ki Teitzei",         "Ki Seitzei",         "Deut. 21:10-25:19","Deut. 21:10-25:19","Is. 54:1-10",            "Is. 54:1-10"},
  {"Ki Tavo",            "Ki Savo",            "Deut. 26:1-29:8",  "Deut. 26:1-29:8",  "Is. 60:1-22",            "Is. 60:1-22"},
  {"Nitzavim",           "Nitzavim",           "Deut. 29:9-30:20", "Deut. 29:2-31:30", "Is. 61:10-63:9",         "Is. 61:10-63:9"},
  {"Vayeilech",          "Vayeilech",          "Deut. 31:1-30",    "Deut. 29:2-31:30", "Is. 55:6-56:8",          "Is. 55:6-56:8"},
  {"Ha'Azinu",           "Ha'Azinu",           "Deut. 32:1-52",    "Deut. 32:1-52",    "II Sam. 22:1-51",        "II Sam. 22:1-51"},
  {"V'Zot Habracha",     "V'Zos Habracha",     "Deut. 33:1-34:12", "Deut. 33:1-34:12", "Jos. 1:1-18",            "Jos. 1:1-9"}
};


#define VAYAKHEL 21
#define TAZRIA 26
#define ACHREI 28
#define BEHAR 31
#define CHUKAT 38
#define MATOT 41
#define NITZAVIM 50

#define NM_LEN 60

#define OWNSEDRA	 0x001
#define NIDCHE		 0x002
#define MUKDAM		 0x004
#define MUKDAM2		 0x008
#define SKIP_NORMAL_ADAR 0x010
#define FULL_HOLIDAY	 0x020
#define EARLY_CANDLES	 0x040
#define LATE_CANDLES	 0x080
#define BOLD		 0x100

static holinput_t inp_holidays[] = {   /* 5 = Adar I */
  /* 6 = Adar =	Adar II	*/
  {{0,1},{"Rosh Hashana I"},OWNSEDRA | FULL_HOLIDAY | EARLY_CANDLES | BOLD },
  {{0,2},{"Rosh Hashana II"},OWNSEDRA |	FULL_HOLIDAY | LATE_CANDLES | BOLD },
  {{0,3},{"Tzom Gedalia"},NIDCHE},
  {{0,9},{"Erev Yom Kippur"},BOLD},
  {{0,10},{"Yom Kippur"},OWNSEDRA | FULL_HOLIDAY | EARLY_CANDLES | BOLD	},
  {{0,15},{"Sukkot I","Sukkos I"},OWNSEDRA | FULL_HOLIDAY | EARLY_CANDLES |BOLD},
  {{0,16},{"Sukkot II","Sukkos II"},OWNSEDRA | FULL_HOLIDAY | LATE_CANDLES |BOLD},
  {{0,17},{"Sukkot III (CH''M)","Sukkos III (CH''M)"},OWNSEDRA},
  {{0,18},{"Sukkot IV (CH''M)","Sukkos IV (CH''M)"},OWNSEDRA},
  {{0,19},{"Sukkot V (CH''M)","Sukkos V (CH''M)"},OWNSEDRA},
  {{0,20},{"Sukkot VI (CH''M)","Sukkos VI (CH''M)"},OWNSEDRA},
  {{0,21},{"Sukkot VII (Hoshana Raba)","Sukkos VII (Hoshana Raba)"},OWNSEDRA},
  {{0,22},{"Shmini Atzeret","Shmini Atzeres"},OWNSEDRA | FULL_HOLIDAY |	EARLY_CANDLES |BOLD},
  {{0,23},{"Simchat Torah","Simchas Torah"},OWNSEDRA | FULL_HOLIDAY | LATE_CANDLES |BOLD},
  {{2,24},{"Erev Chanukah"},BOLD},
  {{2,25},{"Chanukah I"},BOLD},
  {{2,26},{"Chanukah II"}},
  {{2,27},{"Chanukah III"}},
  {{2,28},{"Chanukah IV"}},
  {{3,10},{"Asara B'Tevet"},NIDCHE},
  {{4,15},{"Tu B'Shvat"}},
  {{5,14},{"Purim katan"},SKIP_NORMAL_ADAR},
  {{6,13},{"Ta'anit Esther","Ta'anis Esther"},MUKDAM},
  {{6,14},{"Purim"},BOLD},
  {{6,15},{"Shushan Purim"}},
  {{7,14},{"Erev Pesach"},BOLD},
  {{7,14},{"Ta'anit Bechorot","Ta'anis Bechorot"},MUKDAM},
  {{7,14},{"1st Seder (evening)"},BOLD},
  {{7,15},{"Pesach I"},OWNSEDRA	| FULL_HOLIDAY | EARLY_CANDLES |BOLD},
  {{7,15},{"2nd Seder (evening)"},BOLD},
  {{7,16},{"Pesach II"},OWNSEDRA | FULL_HOLIDAY | LATE_CANDLES |BOLD},
  {{7,17},{"Pesach III (CH''M)"},OWNSEDRA},
  {{7,18},{"Pesach IV (CH''M)"},OWNSEDRA},
  {{7,19},{"Pesach V (CH''M)"},OWNSEDRA},
  {{7,20},{"Pesach VI (CH''M)"},OWNSEDRA},
  {{7,21},{"Pesach VII"},OWNSEDRA | FULL_HOLIDAY | EARLY_CANDLES |BOLD},
  {{7,22},{"Pesach VIII"},OWNSEDRA | FULL_HOLIDAY | LATE_CANDLES |BOLD},
  {{7,27},{"Yom HaShoah"},BOLD},
  {{8,4},{"Yom HaZikaron"},MUKDAM2},
  {{8,5},{"Yom Ha'atzmaut"},MUKDAM},
  {{8,28},{"Yom Yerushalayim"},MUKDAM},
  {{9,6},{"Shavuot I","Shavuos I"},OWNSEDRA | FULL_HOLIDAY | EARLY_CANDLES |BOLD},
  {{9,7},{"Shavuot II","Shavuos II"},OWNSEDRA | FULL_HOLIDAY | LATE_CANDLES |BOLD},
  {{10,17},{"Shiva Assar B'Tamuz"},NIDCHE},
  {{11,9},{"Tish'a B'Av"},BOLD | NIDCHE},
  {{12,29},{"Erev Rosh Hashana"},BOLD}
};

static holstore_t chanukah_arr[5] =
{
  {""},
  {"Chanukah V"},
  {"Chanukah VI"},
  {"Chanukah VII"},
  {"Chanukah VIII",BOLD}
};

static struct special_parshot specials[] = {
  { "New Moon",	"New Moon", 0,-1, 1,  0, 1,"Num. 28:9-15",   "Is 66:1-24",	"Is 66:1-24" },
  { "New Moon", "New Moon", 0,-1,30,  0, 1,"Num. 28:9-15",   "Is 66:1-24",	"Is 66:1-24" },
  { "New Moon", "New Moon", 0,-1,29,  0, 1, NULL,	     "I Sam. 20:18-42",	"I Sam. 20:18-42" },
  { "Shuvah",	"Shuvah",   2, 0, 3,  0, 7, NULL,	     "Ho. 14:2-10 Mic. 7:18-20 Joel 2:15-17",
										"Ho. 14:2-10 Mic. 7:18-20" },
  { "Sukkot",	"Sukkos",   0, 0,17,  0, 1,"Num. 29:17-25",   NULL,		 NULL		  },
  { "Sukkot",	"Sukkos",   0, 0,18,  0, 1,"Num. 29:20-28",   NULL,		 NULL		  },
  { "Sukkot",	"Sukkos",   0, 0,19,  0, 1,"Num. 29:23-31",   NULL,		 NULL		  },
  { "Sukkot",	"Sukkos",   0, 0,20,  0, 1,"Num. 29:26-34",   NULL,		 NULL		  },
  { "Sukkot",	"Sukkos",   0, 0,21,  0, 1,"Num. 29:26-34",   NULL,		 NULL		  },
  { "Sukkot",	"Sukkos",   1, 0,17,  0, 5,"Ex. 33:12-34:26","Ez. 38:18-39:16",	"Ez. 38:18-39:16" },
  { "Chanukah",	"Chanukah", 0, 2,25,  0, 1,"Num. 7:1-17",     NULL,		 NULL },
  { "Chanukah",	"Chanukah", 0, 2,25,  1, 1,"Num. 7:18-23",    NULL,		 NULL },
  { "Chanukah",	"Chanukah", 0, 2,25,  2, 1,"Num. 7:24-29",    NULL,		 NULL },
  { "Chanukah",	"Chanukah", 0, 2,25,  3, 1,"Num. 7:30-35",    NULL,		 NULL },
  { "Chanukah",	"Chanukah", 0, 2,25,  4, 1,"Num. 7:36-41",    NULL,		 NULL },
  { "Chanukah",	"Chanukah", 0, 2,25,  5, 1,"Num. 7:42-47",    NULL,		 NULL },
  { "Chanukah",	"Chanukah", 0, 2,25,  6, 1,"Num. 7:48-53",    NULL,		 NULL },
  { "Chanukah",	"Chanukah", 0, 2,25,  7, 1,"Num. 7:54-8:4",   NULL,		 NULL },
  { "Chanukah",	"Chanukah", 2, 2,25,  0, 7, NULL,	      "Zech, 2:14-4:7",	"Zech, 2:14-4:7" },
  { "Chanukah",	"Chanukah", 2, 2,25,  7, 1, NULL,	      "I Kings 7:40-50", "I Kings 7:40-50" },
  { "Shekalim",	"Shekalim", 2, 6, 1, -6, 7,"Ex. 30:11-16",    "II Kings 12:1-17","II Kings 11:1712:17" },
  { "Zachor",	"Zachor",   2, 6, 7,  0, 7,"Deut. 25:17-19",  "I Sam. 15:2-34",	 "I Sam. 15:1-34" },
  { "Parah",	"Parah",    2, 7, 1,-13, 7,"Num 19:1-22",     "Ez. 36:16-38",	 "Ez. 36:16-36"	},
  { "Hachodesh","Hachodesh",2, 7, 1, -6, 7,"Ex. 12:1-20",     "Ez. 45:16-46:18", "Ez. 45:18-46:15" },
  { "Haggadol",	"Haggadol", 2, 7,14, -6, 7, NULL,	      "Mal. 3:4-24",	 "Mal. 3:4-24" },
  { "Pesah",	"Pesah",    1, 7,17,  0, 4,"Ex. 33:12-34:26 Num 28:19-25",
							      "Ez. 36:37-37:14", "Ez. 37:1-14" },
  { NULL,	NULL,	    0, 0, 0,  0, 0,NULL,   NULL,      NULL	 }
  };

#define SIMCHAT_DAY 23
#define LEAP_YR_HEB(x) (leapYears[((x) -1) % 19])
#define MONTHS_IN_HEB(x) (LEAP_YR_HEB(x) ? 13 :12)

#if defined(PROTOTYPES)
static year_t yearData(int yr)
#else
static year_t yearData(yr) int yr;
#endif
  {
  return legend[LEAP_YR_HEB(yr)][luach[((yr-1)/19+7)%13][(yr-1)	%19]];
  }

#if defined(PROTOTYPES)
static int daysInHebMonth(int month,int year)
#else
static int daysInHebMonth(month,year) int month;int year;
#endif
  {
  year_t theYear;

  theYear = yearData(year);
  if (month == CHESHVAN)
    return theYear.daysInCheshvan;
  else if (month == KISLEV)
    return theYear.daysInKislev;
  else return hMonths[LEAP_YR_HEB(year)][month].length;
  }

#if defined(PROTOTYPES)
static date_t nextHebDate (date_t dth)
#else
static date_t nextHebDate (dth) date_t dth;
#endif
  {
  dth.dd++;
  if (dth.dd > daysInHebMonth(dth.mm,dth.yy))
    if (dth.mm ==  MONTHS_IN_HEB(dth.yy)-1)
      {
	dth.yy++;
	dth.mm =0;
	dth.dd =1;
      }
    else
      {
	dth.mm++;
	dth.dd =1;
      }
  return dth;
  }

#if defined(PROTOTYPES)
static date_t prevHebDate (date_t dth)
#else
static date_t prevHebDate (dth) date_t dth;
#endif
{
  dth.dd--;
  if (dth.dd ==	0)
    if (dth.mm == 0)
      {
	dth.yy--;
	dth.mm = MONTHS_IN_HEB(dth.yy) -1 ;
	dth.dd = daysInHebMonth(dth.mm,dth.yy);
      }
    else
      {
	dth.mm--;
	dth.dd = daysInHebMonth(dth.mm,dth.yy);
      }
  return dth;
}

#if defined(PROTOTYPES)
static holstorep_t getHolstorep	(char *s)    /*	return a pointer to a new */
#else
static holstorep_t getHolstorep	(s) char *s;    /*	return a pointer to a new */
#endif
{
  holstorep_t tmp;
  tmp =	(holstorep_t)new(sizeof	(holstore_t));
  tmp->next = NULL;
  tmp->name = NULL;
  tmp->typeMask	= 0;
  return tmp;
}


/*pushes a copy of a holiday on to a holiday list */
#if defined(PROTOTYPES)
static int PushHoliday (holstorep_t hp,holstorep_t *lp)	
#else
static int PushHoliday (hp,lp) holstorep_t hp;holstorep_t *lp;	
#endif
{
  holstorep_t temp;

  temp = getHolstorep("PushHoliday");
  temp->name=new(MAX_LINE_LEN);
  strcpy(temp->name,hp->name);
  temp->typeMask = hp->typeMask;

  if (!*lp)
    /* if there are no holidays here yet, start a new bucket*/
    *lp	= temp;
  else
    {
      temp->next = *lp;		/* put hp at the head of the list */
      *lp = temp;
    }
  return temp->typeMask;
}


#if defined(PROTOTYPES)
void InitHolidays(void)	      /* set up the stored holidays array */
#else
void InitHolidays()	      /* set up the stored holidays array */
#endif
{

  int d,m;
  holstorep_t tmpholp;
  holinputp_t todayinp;

  for (m = 0; m<= 12; m++)	/* clear holidays buckets */
    for	(d = 0;	d < MAXDAYS; d++)
      holidays[m][d] = NULL;

  for (m = 0,todayinp =	inp_holidays; /* load holiday buckets */
       m < LAST_INDEX(inp_holidays);
       m++, todayinp++)
    {
      tmpholp =	getHolstorep("InitHolidays");	   /* allocate hsnode*/
      tmpholp->typeMask	= todayinp->typeMask;	   /* load the new holiday into it. */
      tmpholp->name = LANGUAGE(todayinp->name);
      PushHoliday(tmpholp,&holidays[todayinp->date.mm][todayinp->date.dd]);
      if ((todayinp->date.mm ==	5 || todayinp->date.mm == 6) &&
	  !(tmpholp->typeMask &	SKIP_NORMAL_ADAR))
	PushHoliday(tmpholp,&union_Adar[todayinp->date.dd]);
    }
}



#if defined(PROTOTYPES)
static void getHebHolidays (date_t dth,int weekday, holstorep_t	*holiList)
#else
static void getHebHolidays (dth,weekday, holiList) 
date_t dth;int weekday; holstorep_t	*holiList;
#endif
{
  char * funName = "getHebHolidays";
  int tmpMask;
  holstorep_t tmpholip, chp;
  static holstorep_t todayp, yesterp, morrowp, morrow2p;
  static int chanukah_day,first;

#define CORRECTION(yy,mm) (LEAP_YR_HEB(yy) ? 0 : (((mm)	> 4) ? 1: 0))

  if (first)
    {
      todayp  =	holidays[dth.mm][dth.dd];
      yesterp =	holidays[prevHebDate(dth).mm][prevHebDate(dth).dd];
      morrowp =	holidays[nextHebDate(dth).mm][nextHebDate(dth).dd];
      morrow2p = holidays[nextHebDate(nextHebDate(dth)).mm]
	[nextHebDate(nextHebDate(dth)).dd];
      first = 0;
    }
  else
    {
      date_t morrow2dt;

      morrow2dt	= nextHebDate(nextHebDate(dth));
      yesterp =	todayp;
      todayp = morrowp;
      morrowp =	morrow2p;
      if (!LEAP_YR_HEB(dth.yy) && morrow2dt.mm == 5)
	morrow2p = union_Adar[morrow2dt.dd];
      else
	morrow2p = holidays[morrow2dt.mm +CORRECTION(dth.yy,morrow2dt.mm)]
	  [morrow2dt.dd];
    }

  tmpMask =0;
  *holiList = NULL;


#define NISAN (6 + LEAP_YR_HEB(dth.yy))
#define SIVAN (NISAN + 2)
  if (dth.mm ==	NISAN && dth.dd	== 16) /* 2nd day of pesach */
    omer++;
  if (omer && dth.mm ==	SIVAN && dth.dd	== 6 ) /*shavuot*/
    omer = 0;

  for (chp = todayp; chp; chp =	chp->next)
    {
      /* for normal holidays */
      if (!(weekday == SATURDAY && chp->typeMask & NIDCHE) &&
	  !(chp->typeMask & MUKDAM  && (weekday	== FRIDAY || weekday == SATURDAY)) &&
	  !(chp->typeMask & MUKDAM2 && (weekday	== THURSDAY || weekday == FRIDAY)))
	tmpMask	|= PushHoliday(chp,holiList);	     /*	do normal holidays*/
    }

  if (weekday == SUNDAY &&	yesterp)      /* fast days which are nidche */
    for	(chp = yesterp;	chp; chp = chp->next)
      if (chp->typeMask	& NIDCHE)
	{
	  char *st;

	  st=new(NM_LEN);
	  strncat(st,chp->name,NM_LEN);
	  strncat(st," [nidche]",NM_LEN);
	  tmpMask |= PushHoliday(chp,holiList);
	  (*holiList)->name = st;
	}

  /* if the date actually falls	*/
  /* on friday or shabbat*/
  if (weekday == THURSDAY)
    {
      for (chp = morrowp; chp; chp = chp->next)
	if (chp->typeMask & MUKDAM)
	  {
	    char *st;

	    st=new(NM_LEN);
	    strncat(st,chp->name,NM_LEN);
	    strncat(st," [mukdam]",NM_LEN);
	    tmpMask |= PushHoliday(chp,holiList);
	    (*holiList)->name =	st;
	  }
      for (chp = morrow2p; chp;	chp = chp->next)
	if (chp->typeMask & MUKDAM)
	  {
	    char *st;

	    st=new(NM_LEN);
	    strncat(st,chp->name,NM_LEN);
	    strncat(st," [mukdam]",NM_LEN);
	    tmpMask |= PushHoliday(chp,holiList);
	    (*holiList)->name =	st;
	  }
    }

  /* if the date actually falls	*/
  /* on thursday or friday*/
  if (weekday == WEDNESDAY)
    {
      for (chp = morrowp; chp; chp = chp->next)
	if (chp->typeMask & MUKDAM2)
	  {
	    char *st;

	    st=new(NM_LEN);
	    strncat(st,chp->name,NM_LEN);
	    strncat(st," [mukdam]",NM_LEN);
	    tmpMask |= PushHoliday(chp,holiList);
	    (*holiList)->name =	st;
	  }
      for (chp = morrow2p; chp;	chp = chp->next)
	if (chp->typeMask & MUKDAM2)
	  {
	    char *st;

	    st=new(NM_LEN);
	    strncat(st,chp->name,NM_LEN);
	    strncat(st," [mukdam]",NM_LEN);
	    tmpMask |= PushHoliday(chp,holiList);
	    (*holiList)->name =	st;
	  }
    }

  /* Lag B'Omer Processing */
  if (omer == 33) {
    tmpholip = getHolstorep(funName);
    tmpholip->name=new(NM_LEN);
    strncpy(tmpholip->name,"Lag B'Omer",NM_LEN);
    tmpMask |= PushHoliday(tmpholip,holiList);
  }

  if (dth.dd ==	25 && dth.mm ==	2)
    chanukah = 1;
  if (dth.dd ==	29 && dth.mm ==	2)
    chanukah_day = 1;
  if (chanukah == 9)
    chanukah = 0;

  if (chanukah_day) {
    tmpMask |= PushHoliday(&chanukah_arr[chanukah_day],holiList);
    if (chanukah_day ==	4)
      chanukah_day = 0;
    else chanukah_day++;
  }


  /* rosh Chodesh Processing...	*/
  if (dth.dd ==	1 && dth.mm){	/* every 1st of the month except tishrei */
    tmpholip = getHolstorep(funName);
    tmpholip->name=new(NM_LEN);
    strcat(tmpholip->name,"Rosh Chodesh");
      /* strncat(tmpholip->name,hMonths[LEAP_YR_HEB(dth.yy)][dth.mm].name,NM_LEN); */
    tmpMask |= PushHoliday(tmpholip,holiList);
  }
  if (dth.dd ==	30){
    tmpholip = getHolstorep(funName);
    tmpholip->name=new(NM_LEN);
    strcat(tmpholip->name,"Rosh Chodesh");
      /* strncat(tmpholip->name,hMonths[LEAP_YR_HEB(dth.yy)][dth.mm+1].name,NM_LEN); */
    tmpMask |= PushHoliday(tmpholip,holiList);
  }

  if (*holiList) (*holiList)->typeMask = tmpMask;

}

#if defined(PROTOTYPES)
static void incHebJulDate(date_t *dth,date_t *dtj,int *wkday)
#else
static void incHebJulDate(dth,dtj,wkday)
date_t *dth;date_t *dtj;int *wkday;
#endif
{
  /* increments both hebrew and julian calendars */

  incDate (dtj,1);
  *wkday = dayOfWeek(*dtj);
  *dth = nextHebDate(*dth);
}


#if defined(PROTOTYPES)
static char *DoSedra (int *sedra,year_t ydat) /* returns a string "Parshat <parsha>" */
#else
static char *DoSedra (sedra,ydat) /* returns a string "Parshat <parsha>" */
int *sedra;year_t ydat; /* returns a string "Parshat <parsha>" */
#endif
{
  switch (*sedra)
    {
    case VAYAKHEL :
      if (ydat.vayakhelPikudei)
	  *sedra += 2;
      else *sedra += 1;
      break;
    case TAZRIA:
      if (ydat.tazriaMetzorah)
	  *sedra += 2;
      else *sedra += 1;
      break;
    case ACHREI :
      if (ydat.achreiKedoshim)
	  *sedra += 2;
      else *sedra += 1;
      break;
    case BEHAR :
      if (ydat.beharBech)
	  *sedra += 2;
      else *sedra += 1;
      break;
    case CHUKAT :
      if (ydat.chukatBalak)
	  *sedra += 2;
      else *sedra += 1;
      break;
    case MATOT :
      if (ydat.matotMasei)
	  *sedra += 2;
      else *sedra += 1;
      break;
    case NITZAVIM :
      if (ydat.nitzavimVayelech)
	  *sedra += 2;
      else *sedra += 1;
      break;
    case LAST_INDEX(sedrot)-1:
      *sedra = 0;
      break;
    default:
      *sedra +=	1;
    }
}

#if defined(PROTOTYPES)
static void DoCalendar (date_t myDate,day_data_t *day_data)
#else
static void DoCalendar (myDate,day_data)
date_t myDate;day_data_t *day_data;
#endif
{
  static date_t roshDt = { SEP, 28, 1992 };
  static int weekday;
  static date_t todayj, todayh;
  static sedra,first = 1;
  holstorep_t holip;		/* a list of holidays for today */
  static year_t theYear;
  info_t *new_info_t;
  int old_sedra;
  int length;
  char *ch;
  date_t spec_date;
  struct special_parshot *sptr;
  int found;
  int count;

  if (first || todayj.yy != myDate.yy || todayj.mm > myDate.mm ||
      (todayj.mm == myDate.mm && todayj.dd > myDate.dd))
    {
    roshDt.mm =	SEP;
    roshDt.dd =	28;
    roshDt.yy =	1992;

    if (myDate.yy < roshDt.yy +1) /* go to R"H of the year before */
      RollBack(&roshDt,myDate.yy);
    else if (myDate.yy > roshDt.yy +1) /* start from there */
      RollForward(&roshDt,myDate.yy);

    todayj = roshDt;
    first = 0;
    todayh.mm =	0;
    todayh.dd =	1;
    todayh.yy =	JUL2HEB(roshDt.yy) + 1;	/* because it's after R"H */
    chanukah = 0;
    omer = 0;

    theYear = yearData(todayh.yy);

    /* first scan forward to simchat Torah, keeping track of dates only. */
    while (todayh.dd !=	SIMCHAT_DAY)
      incHebJulDate(&todayh, &todayj,&weekday);

    sedra = 0;		  /* initialize sedra */

    /* then continue until January 1. */
      while (!(todayj.mm==0 && todayj.dd==1))
      {
	getHebHolidays(todayh,weekday,&holip);
	if (weekday == SATURDAY && !(holip && holip->typeMask & OWNSEDRA))
	  DoSedra(&sedra,theYear);
	incHebJulDate(&todayh,&todayj,&weekday);
        if (chanukah) chanukah++;
        if (omer) omer++;
      }
    }
  /* then continue until Day you want. */
    while (!(todayj.mm==myDate.mm && todayj.dd==myDate.dd))
    {
      getHebHolidays(todayh,weekday,&holip);
      if (todayh.mm == TISHREI && todayh.dd == 1)
	theYear = yearData(todayh.yy); /* if R"H reset YearData */
      if (todayh.mm == TISHREI && /* reset the sedra on simchat torah */
	  todayh.dd == SIMCHAT_DAY)
	sedra =0;
      if (weekday == SATURDAY && !(holip && holip->typeMask & OWNSEDRA))
	DoSedra(&sedra,theYear);
      incHebJulDate(&todayh,&todayj,&weekday);
      if (omer)	omer++;
      if (chanukah) chanukah++;
    }

      day_data->jmonth = mk_string(hMonths[LEAP_YR_HEB(todayh.yy)][todayh.mm].name);
      day_data->jday = todayh.dd;
      day_data->jyear =	todayh.yy;
      day_data->mitzvah = NULL;
      day_data->holiday = NO;
      day_data->candles.word1 = 0;
      day_data->candles.word2 = 0;
      day_data->shabbat = NULL;
      day_data->chanukah = 0;
      day_data->omer = 0;
      day_data->info = NULL;
      day_data->info_last = NULL;
      day_data->shaharit.word1 = 0;
      day_data->shaharit.word2 = 0;
      day_data->mincha.word1 = 0;
      day_data->mincha.word2 = 0;
      day_data->mariv.word1 = 0;
      day_data->mariv.word2 = 0;
      day_data->edited = SET_PRAYER_DEFAULT;
      day_data->autogenerated;

      getHebHolidays(todayh,weekday,&holip);

      if (todayh.mm == TISHREI && todayh.dd == 1)
	theYear = yearData(todayh.yy); /* if R"H reset YearData	*/

      if (weekday==SUNDAY)
	day_data->candles.word1 = TIME_CANDLES_HAVDALAH;

      if (weekday==SATURDAY)
	{
	day_data->candles.word1 = TIME_CANDLES_EARLY;
	day_data->shabbat = (shabbat_t *)new(sizeof(shabbat_t));
	day_data->shabbat->autogenerated = YES;
        day_data->edited &= ~(SET_PRAYER_MASK);
        day_data->edited |= SET_PRAYER_SHABBAT;
	if (!(holip && holip->typeMask & OWNSEDRA))
		{
		old_sedra = sedra;
		DoSedra(&sedra,theYear);
		if (sedra - old_sedra == 2)
		  {
		  length = strlen(sedrot[sedra - 2][flag_a]) + 2 +
			   strlen(sedrot[sedra - 1][flag_a]);
		  day_data->shabbat->name =	(char *)new(length);
		  strcpy(day_data->shabbat->name,sedrot[sedra - 2][flag_a]);
		  strcat(day_data->shabbat->name,"-");
		  strcat(day_data->shabbat->name,sedrot[sedra - 1][flag_a]);
			day_data->shabbat->torah =
		      mk_string(sedrot[sedra - 1][TWO_TORAH_READING]);
		  }
		else
		  {
		  day_data->shabbat->name =
		      mk_string(sedrot[sedra - 1][flag_a]);
			day_data->shabbat->torah =
		      mk_string(sedrot[sedra - 1][TORAH_READING]);
		  }
		if (flag_S)
			day_data->shabbat->prophet =
		      mk_string(sedrot[sedra - 1][SEPHARDIC_PROPHET]);
		else
			day_data->shabbat->prophet =
		      mk_string(sedrot[sedra - 1][ASHKENAZI_PROPHET]);
		}
	for (sptr = specials;sptr->ashkenazic_name;sptr++)
		{
		spec_date.mm = sptr->base_month;
		spec_date.dd = sptr->base_day;
		spec_date.yy = todayh.yy;
		if (MONTHS_IN_HEB(spec_date.yy)	== 12 && spec_date.mm >	5)
		  spec_date.mm--;
		if (sptr->days_from_base < 0)
			{
			for (count = 0;count > sptr->days_from_base;count--)
				spec_date = prevHebDate(spec_date);
			}
		else if (sptr->days_from_base >	0)
			{
			for (count = 0;count < sptr->days_from_base;count++)
				spec_date = nextHebDate(spec_date);
			}
		for (found = NO,count =	0;
		     count < sptr->number_of_days && !found;
		     count++)
			{
			if ((spec_date.mm == -1 || spec_date.mm == todayh.mm) &&
			    (spec_date.dd == todayh.dd))
				found =	YES;
			spec_date = nextHebDate(spec_date);
			}
		if (found)
			{
			if (sptr->addname == 1)
				{
				if (day_data->shabbat->name)
					free(day_data->shabbat->name);
				day_data->shabbat->name = mk_string(
					flag_a ? sptr->ashkenazic_name
					       : sptr->sephardic_name);
				}
			else if (sptr->addname == 2)
			    day_data->shabbat->name =
				stradd(day_data->shabbat->name,"-",
				flag_a ? sptr->ashkenazic_name
				       : sptr->sephardic_name);
			day_data->shabbat->torah	=
			    stradd(day_data->shabbat->torah," ",sptr->torah);
			if (sptr->ashkenazic_prophet)
				{
				if (day_data->shabbat->prophet)
				   free(day_data->shabbat->prophet);
				day_data->shabbat->prophet = mk_string(flag_S ?
					sptr->sephardic_prophet	:
					sptr->ashkenazic_prophet);
				}
			}
		}
	day_data->shabbat->schedule = NULL;
	}


      if (todayh.mm == TISHREI && /* reset the sedra on simchat torah */
	  todayh.dd == SIMCHAT_DAY)
	sedra =0;

	for (;holip;holip = holip->next)
	    {
	    new_info_t = (info_t *)new(sizeof(info_t));
	    new_info_t->time.word1 = 0;
	    new_info_t->time.word2 = 0;
	    new_info_t->calendar = mk_string(holip->name);
	    new_info_t->schedule = NULL;
	    if (holip->typeMask	& FULL_HOLIDAY)
	      {
	      day_data->holiday	= YES;
	      if (minyan[CHAG][SHAHARIT].word1 || minyan[CHAG][MINCHA].word1 || minyan[CHAG][MARIV].word1) 
		  {
                  day_data->edited &= ~(SET_PRAYER_MASK);
                  day_data->edited |= SET_PRAYER_SHABBAT;
		  }
	      }
	    if (strcmp(holip->name,"Rosh Chodesh") == 0)
		{
		if (todayh.dd == 30)
			  new_info_t->schedule = mk_string(hMonths[LEAP_YR_HEB(todayh.yy)][todayh.mm + 1].name);
		else
		    new_info_t->schedule = mk_string(day_data->jmonth);
	        if (minyan[ROSH][SHAHARIT].word1 || minyan[ROSH][MINCHA].word1 || minyan[ROSH][MARIV].word1) 
		    {
                    day_data->edited &= ~(SET_PRAYER_MASK);
                    day_data->edited |= SET_PRAYER_SHABBAT;
		    }
		}
	    new_info_t->items =	break_up(0,NULL,holip->name,holip->typeMask & BOLD,NULL);
	    if (holip->typeMask	& BOLD)
	      new_info_t->bold = YES;
	    else
	      new_info_t->bold = NO;
	    add_to_day(day_data,new_info_t);
	    if (!day_data->candles.word1)
	      {
	      if (holip->typeMask & LATE_CANDLES)
		day_data->candles.word1 = TIME_CANDLES_LATE;
	      else if (holip->typeMask & EARLY_CANDLES)
		if (day_data->candles.word1 == TIME_CANDLES_HAVDALAH)
		  day_data->candles.word1 = TIME_CANDLES_LATE;
		else
		  day_data->candles.word1 = TIME_CANDLES_EARLY;
	      }
	    }

      switch(day_data->edited & SET_PRAYER_MASK)
	{
	case SET_PRAYER_CHAG:
            day_data->shaharit.word1 = minyan[CHAG][SHAHARIT].word1;
            day_data->shaharit.word2 = minyan[CHAG][SHAHARIT].word2;
            day_data->mincha.word1 = minyan[CHAG][MINCHA].word1;
            day_data->mincha.word2 = minyan[CHAG][MINCHA].word2;
            day_data->mariv.word1 = minyan[CHAG][MARIV].word1;
            day_data->mariv.word2 = minyan[CHAG][MARIV].word2;
	  break;
	case SET_PRAYER_ROSH:
            day_data->shaharit.word1 = minyan[ROSH][SHAHARIT].word1;
            day_data->shaharit.word2 = minyan[ROSH][SHAHARIT].word2;
            day_data->mincha.word1 = minyan[ROSH][MINCHA].word1;
            day_data->mincha.word2 = minyan[ROSH][MINCHA].word2;
            day_data->mariv.word1 = minyan[ROSH][MARIV].word1;
            day_data->mariv.word2 = minyan[ROSH][MARIV].word2;
	  break;
        default :
            day_data->shaharit.word1 = minyan[weekday][SHAHARIT].word1;
            day_data->shaharit.word2 = minyan[weekday][SHAHARIT].word2;
            day_data->mincha.word1 = minyan[weekday][MINCHA].word1;
            day_data->mincha.word2 = minyan[weekday][MINCHA].word2;
            day_data->mariv.word1 = minyan[weekday][MARIV].word1;
            day_data->mariv.word2 = minyan[weekday][MARIV].word2;
	  break;
	}

      /* print the omer if desired */
      if (omer)
	{
	day_data->omer = omer;
	omer++;
	}
      if (chanukah)
	{
	day_data->chanukah = chanukah;
	chanukah++;
	}
      incHebJulDate(&todayh,&todayj,&weekday);

}

#if defined(PROTOTYPES)
static void RollBack(date_t *dtg,int target) /*	move rosh hashana dtj back until it's */
#else
static void RollBack(dtg,target) /*	move rosh hashana dtj back until it's */
date_t *dtg;int target; /*	move rosh hashana dtj back until it's */
#endif
{
  int days,theyear;

  for (days = 0,theyear	= dtg->yy ;theyear > target -1;	theyear--)
    days +=yearData(JUL2HEB(theyear)).length;
  decDate (dtg,days);

}

#if defined(PROTOTYPES)
static void RollForward(date_t *dtg,int target)	  /* move rosh hashana dtg forward until it's*/
#else
static void RollForward(dtg,target)	  /* move rosh hashana dtg forward until it's*/
date_t *dtg;int target;	  /* move rosh hashana dtg forward until it's*/
#endif
{
  int days,theyear;

  for (days = 0,theyear	= dtg->yy ;theyear < target -1;	theyear++)
    days +=yearData(JUL2HEB(theyear+1)).length;
  incDate (dtg,days);

}


#if defined(PROTOTYPES)
void do_date (int month,int day,int year,day_data_t *day_data)
#else
void do_date (month,day,year,day_data)
int month;int day;int year;day_data_t *day_data;
#endif
{
  date_t myDate;

  myDate.yy = year;
  myDate.mm = month;
  myDate.dd = day;

  DoCalendar(myDate,day_data);
}

static int MonthLengths[][12] ={
  {31,28,31,30,31,30,31,31,30,31,30,31},
  {31,29,31,30,31,30,31,31,30,31,30,31}
};

#if defined(PROTOTYPES)
static long int daysSinceOrigin	(date_t dt)
#else
static long int daysSinceOrigin	(dt) date_t dt;
#endif
{
  int m,y;
  long int days	= 0L;

  for (y =1; y < dt.yy;	y++)
    days += DAYS_IN(y);
  y = dt.yy;
  for (m= JAN; m < dt.mm; m++)
    days += MonthLengths[LEAP(y)][m];
  days += dt.dd	-1;
  return days;
}

#if defined(PROTOTYPES)
static void decDate (date_t *dt,int n) /* decrements dt by n days */
#else
static void decDate (dt,n) date_t *dt;int n; /* decrements dt by n days */
#endif
{
  while	(n--)
    if (dt->dd ==1) {
      if (dt->mm == JAN) {
	dt->yy--;
	dt->mm = DEC;
	dt->dd = 31;
      }
      else {
	dt->mm--;
	dt->dd = MonthLengths[LEAP(dt->yy)][dt->mm];
      }
    }
    else dt->dd--;
}

#if defined(PROTOTYPES)
static void incDate (date_t *dt,int n)	 /* increments dt by n days */
#else
static void incDate (dt,n) date_t *dt;int n;	 /* increments dt by n days */
#endif
{
  while	(n--)
   if ((dt->dd + 1) > MonthLengths[LEAP(dt->yy)][dt->mm])
     if	(dt->mm	== DEC)	{
       dt->yy++;
       dt->mm =	JAN;
       dt->dd =	1;
     }
     else {
       dt->mm++;
       dt->dd =1;
     }
   else
     dt->dd ++;
}

#if defined(PROTOTYPES)
static int dayOfWeek(date_t d1)	 /* sunday = 0 */
#else
static int dayOfWeek(d1) date_t d1;	 /* sunday = 0 */
#endif
{
  return (int) ((daysSinceOrigin(d1) + 1) % 7 )	;
}
