static char version[] =
"hcal version 1.0 - postscript hebrew calendar generator\n\n\
copyright 1994,1995 - Steven Weintraub";

/*
 
    hcal version 1.0 - postscript hebrew calendar generator
    copyright 1994,1995 - Steven Weintraub
 
    This program is created and distribed by Steven Weintraub. It
    can be freely distributed without permission as long as this
    head is retained in all files it appears and the LICENCE file
    accompanies it.
 
*/

#include "hcal.h"

int		  asking			= NO;
int		  changed			= NO;
int		  changed_all			= NO;
city_t		 *cities			= NULL;
city_t		  cities_orig[]			= {
	{ "Austin",	30,16,0, 97, 45,0,-6, 3,1, 9,-1,NULL,NULL,NULL },
	{ "Boston",	42,21,0, 71,  4,0,-5, 3,1, 9,-1,NULL,NULL,NULL },
	{ "Chicago",	41,53,0, 87, 38,0,-6, 3,1, 9,-1,NULL,NULL,NULL },
	{ "London",	51,30,0,  0, 10,0, 0,-1,8,-1, 8,NULL,NULL,NULL },
	{ "Los Angeles",34,46,0,118, 15,0,-8, 3,1, 9,-1,NULL,NULL,NULL },
	{ "Jerusalem",	31,46,0,-35,-13,0, 2,-1,8,-1, 8,NULL,NULL,NULL },
	{ "Tel Aviv",	32, 3,0,-34,-46,0, 2,-1,8,-1, 8,NULL,NULL,NULL },
	{ "New York",	40,43,0, 74,  2,0,-5, 3,1, 9,-1,NULL,NULL,NULL },
	{ NULL,		 0, 0,0,  0,  0,0, 0, 0,0, 0, 0,NULL,NULL,NULL }
};
city_t		 *city				= NULL;
int		  city_number			= 0;
cur_slist_t	 *city_slist			= NULL;
int		  current_month			= -1;
int		  current_year			= -1;
day_data_t	  day[33];
int		  delete			= NO;
int		  draw_month			= YES;
int		  dirty				= NO;
file_info_t	 *file_bottom			= NULL;
file_info_t	 *file_current			= NULL;
int		  first_week_day;
int		  flag_a			= NO;
char		 *flag_c			= NULL;
int		  flag_C			= NO;
int		  flag_i			= NO;
int		  flag_I			= NO;
int		  flag_L			= NO;
char		 *flag_o			= NULL;
char		 *flag_p			= NULL;
int		  flag_q			= NO;
char		 *flag_s			= NULL;
int		  flag_S			= NO;
char		 *flag_t			= NULL;
cur_alist_t	 *main_menu			= NULL;
int		  margin_bottom			= BOTTOM_MARGIN;
int		  margin_left			= LEFT_MARGIN;
int		  margin_right			= RIGHT_MARGIN;
int		  margin_top			= TOP_MARGIN;
cur_mlist_t	 *menu_candles			= NULL;
cur_mlist_t	 *menu_city			= NULL;
cur_mlist_t	 *menu_general			= NULL;
cur_mlist_t	 *menu_jdate			= NULL;
cur_mlist_t	 *menu_minyan_add		= NULL;
cur_mlist_t	 *menu_minyan_edit		= NULL;
cur_mlist_t	 *menu_mitzvah			= NULL;
cur_mlist_t	 *menu_shabbat			= NULL;
cur_mlist_t	 *menu_time_regular		= NULL;
cur_mlist_t	 *menu_time_zamin		= NULL;
cur_mlist_t	 *menu_time_zamin_day		= NULL;
char		 *menu_list_candles[]		= {
	"Candles time:l:1:y:y:Early:Late:Havdalah:None",
	 NULL
 };
char		 *menu_list_city[]		= {
	"City:oC::y:y",
	"Latitute:ol::y:y:",
	"Longitude:oL::y:y:",
	"Time (hours) off GMT:i:0:y:y:-12:12",
	"Month DST starts:l::y:n:January:February:March:April:May:June:July:August:September:October:November:December:No DST",
	"Weekend DST starts:l::y:n:First:Second:Third:Forth:Last:Second to Last:Third to Last:No DST",
	"Month DST ends:l::y:n:January:February:March:April:May:June:July:August:September:October:November:December:No DST",
	"Weekend DST ends:l::y:n:First:Second:Third:Forth:Last:Second to Last:Third to Last:No DST",
	NULL
};
char		 *menu_list_general[]		= {
	"Day of Month:oD::y:y:",
	"Font:l:1:y:y:Regular:Bold",
	"Time:ot::y:n:",
	"Calendar Information:os::y:n:",
	"Long Information:s::y:n:",
	NULL
};
char		 *menu_list_jdate[]		= {
	"Day of Month:od::n:n:",
	"Jewish Month:l:1:y:y:Tishrei:Cheshvan:Kislev:Tevet:Sh'vat:Adar:Adar I:Adar II:Nisan:Iyyar:Sivan:Tamuz:Av:Elul",
	"Jewish Day:i:1:y:y:1:30",
	"Jewish Year:i:5753:y:y",
	NULL
};
char		 *menu_list_minyan_add[]	= {
	"Day of Month:od::y:y:",
	"Shaharit:ot::y:n:",
	"Mincha:ot::y:n:",
	"Mariv:ot::y:n:",
	NULL
};
char		 *menu_list_minyan_edit[]	= {
	"Day of Month:s::n:n:",
	"Shaharit:ot::y:n:",
	"Mincha:ot::y:n:",
	"Mariv:ot::y:n:",
	NULL
};
char		 *menu_list_mitzvah[]		= {
	"Day of Month:ob::y:n:",
	"Type:l:1:y:y:Bar:Bat:B'nei:B'not",
	"Format:l:1:y:y:Bar Mitzvah of <name>:<name> Bar Mitzvah",
	"Name:s::y:n:",
	"Long Information:s::y:n:",
	NULL
};
char		 *menu_list_shabbat[]		= {
	"Day of Month:oS::y:y:",
	"Name:s::y:y:",
	"Torah:s::y:y:",
	"Prophet:s::y:y:",
	"Long Information:s::y:n:",
	NULL
};
char		 *menu_list_time_regular[]		= {
	"Hour:i:8:y:y:1:12",
	"Minute:i:0:y:y:0:59",
	"AM or PM:l:2:y:y:AM:PM",
	NULL
};
char		 *menu_list_time_zamin[]		= {
	"Base:s::n:n:",
	"Offset in minutes:i:0:y:y:-240:240",
	"Round in minutes:i:0:y:y:-60:60",
	"Mininum Time:B:0:y:y:",
	"Maxinum Time:B:0:y:y:",
	NULL
};
char		 *menu_list_time_zamin_day[]		= {
	"Base:s::n:n:",
	"Zamin Hour:i:6:y:y:0:11",
	"Zamin Minute:i:0:y:y:0:59",
	"Round in minutes:i:0:y:y:-60:60",
	"Mininum Time:B:0:y:y:",
	"Maxinum Time:B:0:y:y:",
	NULL
};
time_info_t		  minyan[10][3];
char			*mitztypes[]		= {"Bar","Bat","B'nei","B'not"};
char		 *month[]			= {
	"January",  "February","March",  "April",
	"May",      "June",    "July",    "August",
	"September","October","November","December"};
int		  month_length[]		= {
	31,28,31,30,31,30,31,31,30,31,30,31
};
int		  month_lengths[]		= {
	0,31,59,90,120,151,181,212,243,273,304,334
};
cur_slist_t	 *month_menu			= NULL;
int		  numdays;
ptable_t	**parse_entry			= NULL;
ptable_t	**parse_entry_time		= NULL;
int		  parse_errors			= 0;
char		 *parse_error_table[MAX_STR];
int		  parse_first			= YES;
int		  parse_have_month		= NO;
int		  parse_int_1;
int		  parse_int_2;
int		  parse_int_3;
time_info_t	  parse_time_1;
time_info_t	  parse_time_2;
time_info_t	  parse_time_3;
char		  parse_string_1[MAX_STR];
char		  parse_string_2[MAX_STR];
char		  parse_string_3[MAX_STR];
char		  parse_string_4[MAX_STR];
int		  parse_string_level		= 0;
char		  print_file_name[MAX_STR];
char		 *program;
int		  read_buffer[MAX_STR];
int		 *read_end;
int		 *read_place;
int		 *read_token_start;
char		  save_file_name[MAX_STR];
char		  schedule_file_name[MAX_STR];
int		  show_all			= YES;
int		  tdirty			= NO;
char		  template_file_name[MAX_STR];
char 		 *time_types[] = {
				"None",
				"Normal",
				"Noon",
				"Midnight",
				"Sunrise",
				"Zman tefilah",
				"Halachic midday",
				"Halachic midnight",
				"Mincha gadola",
				"Mincha katana",
				"Plug hamincha",
				"Candlelighting",
				"Sunset",
				"Three stars",
				"Zamin day",
				"Zamin night",
				NULL };
cur_slist_t	 *time_types_slist		= NULL;
char		 *weekth[]			= {
	"","First","Second","Third","Forth","Last","Second to Last",
	"Third to Last"
};
char		 *weekdays[]			= {
	"Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Shabbat"
};
char		 *ps_front[]			= {
	"%!",
	"",
	NULL
};
char		 *ps_middle[]			= {
	"",
	"612 0 translate 90 rotate",
	"0.1 setlinewidth",
	"/HEIGHT      612 def",
	"/WIDTH       792 def",
	"/MONTH_SIZE   30 def",
	"/DAY_SIZE     17 def",
	"/BOX_HEIGHT   97 def",
	"/BOX_WIDTH   102 def",
	"",
	"/FONT        /Helvetica      def",
	"/BOLD        /Helvetica-Bold def",
	"",
	"/TOP          HEIGHT   TOP_MARGIN    sub def",
	"/TOP_LINE     TOP MONTH_SIZE         sub def",
	"/TOP_CAL      TOP_LINE DAY_SIZE      sub def",
	"/CAL_HEIGHT   TOP_LINE BOTTOM_MARGIN sub def",
	"",
	"/RIGHT_SIDE   WIDTH RIGHT_MARGIN     sub def",
	"/LEFT_SIDE    LEFT_MARGIN                def",
	"/CAL_WIDTH    RIGHT_SIDE LEFT_MARGIN sub def",
	"",
	"/BOXES MDAYS START_DAY add 5 add 7 idiv def",
	"/BOX_HEIGHT TOP_CAL BOTTOM_MARGIN sub BOXES div def",
	"",
	"BOXES 6 eq",
	"	{ /MDAY_SIZE 15 def }",
	"	{ /MDAY_SIZE 22 def } ifelse",
	"/JDAY_SIZE 10 def",
	"",
	"/TMPS 20 string def",
	"",
	"% procedures",
	"",
	"/DO_FONT { findfont exch scalefont setfont } def",
	"/GET_BOX { START_DAY add 2 sub dup",
	"	7 mod BOX_WIDTH mul LEFT_SIDE add /BOXX exch def",
	"	7 idiv BOXES 1 sub exch sub BOX_HEIGHT mul BOTTOM_MARGIN add /BOXY",
	"	exch def } def",
	"/SHAHARIT { exch GET_BOX 8 FONT DO_FONT",
	"	BOXX 3 add BOXY BOX_HEIGHT add 10 sub moveto show",
	"	} def",
	"/MINCHA { exch GET_BOX 8 FONT DO_FONT",
	"	BOXX 3 add BOXY 9 add moveto show",
	"	} def",
	"/MARIV { exch GET_BOX 8 FONT DO_FONT",
	"	BOXX 3 add BOXY 1 add moveto show",
	"	} def",
	"/MITZVAH  {",
	"	12 BOLD DO_FONT",
	"	4 -1 roll 1 sub GET_BOX",
	"	dup stringwidth pop",
	"	3 -1 roll",
	"	dup stringwidth pop",
	"	exch",
	"	4 1 roll",
	"	add",
	"	4 -1 roll",
	"	1 eq { ( Mitzvah of ) stringwidth pop add",
	"	BOX_WIDTH 2 mul exch sub 2 div BOXX add",
	"	BOXY BOX_HEIGHT add 14 sub MDAY_SIZE sub moveto",
	"	show ( Mitzvah of ) show show",
	"	}",
	"	{ ( Mitzvah ) stringwidth pop add",
	"	BOX_WIDTH 2 mul exch sub 2 div BOXX add",
	"	BOXY BOX_HEIGHT add 14 sub MDAY_SIZE sub moveto",
	"	exch show ( ) show show ( Mitzvah) show",
	"	} ifelse",
	"	} def",
	"/CANDLES  {",
	"	newpath",
	"	exch GET_BOX",
	"	MDAY_SIZE 2 sub FONT DO_FONT",
	"	/TMPX BOXX BOX_WIDTH add (99) stringwidth pop sub 15 sub def",
	"	/TMPY BOXY BOX_HEIGHT add 20 sub def",
	"	TMPX TMPY moveto 4   0 rlineto 0  10 rlineto -4 0 rlineto",
	"	closepath stroke",
	"	TMPX 2 add TMPY 13 add 2 0 360 arc fill",
	"	newpath",
	"	TMPX TMPY 13 add moveto 2   5 rlineto 2  -5 rlineto",
	"	closepath fill",
	"	newpath",
	"	TMPX 5 add TMPY moveto 4   0 rlineto 0 10 rlineto -4 0 rlineto",
	"	closepath stroke",
	"	TMPX 7 add TMPY 13 add 2 0 360 arc fill",
	"	newpath",
	"	TMPX 5 add TMPY 13 add moveto 2   5 rlineto 2  -5 rlineto",
	"	closepath",
	"	fill",
	"	8 FONT DO_FONT",
	"	dup stringwidth pop TMPX exch sub 2 sub TMPY 3 add moveto show",
	"	} def",
	"/CHANUKA_FLAME {",
	"	dup 3 -1 roll dup 4 1 roll exch",
	"	newpath .8 0 360 arc fill",
	"	newpath moveto -.4 0 rlineto .4 1.5 rlineto .4 -1.5 rlineto ",
	"	closepath fill",
	"	} def",
	"/CHANUKAH  {",
	"	newpath",
	"	exch GET_BOX",
	"	8 FONT DO_FONT",
	"	/TMPX BOXX (10:00) stringwidth pop add 14 add def",
	"	/TMPY BOXY BOX_HEIGHT add 10 sub def",
	"	TMPX TMPY moveto ",
	"	newpath TMPX TMPY 8 180 0 arc stroke",
	"	newpath TMPX TMPY 6 180 0 arc stroke",
	"	newpath TMPX TMPY 4 180 0 arc stroke",
	"	newpath TMPX TMPY 2 180 0 arc stroke",
	"	newpath TMPX TMPY 2 add moveto TMPX TMPY 14 sub lineto stroke",
	"	TMPX TMPY 4 add CHANUKA_FLAME",
	"	dup 8 ge { TMPX 8 sub TMPY 2 add CHANUKA_FLAME } if",
	"	dup 7 ge { TMPX 6 sub TMPY 2 add CHANUKA_FLAME } if",
	"	dup 6 ge { TMPX 4 sub TMPY 2 add CHANUKA_FLAME } if",
	"	dup 5 ge { TMPX 2 sub TMPY 2 add CHANUKA_FLAME } if",
	"	dup 1 ge { TMPX 8 add TMPY 2 add CHANUKA_FLAME } if",
	"	dup 2 ge { TMPX 6 add TMPY 2 add CHANUKA_FLAME } if",
	"	dup 3 ge { TMPX 4 add TMPY 2 add CHANUKA_FLAME } if",
	"	4 ge { TMPX 2 add TMPY 2 add CHANUKA_FLAME } if",
	"	} def",
	"/OMER {",
	"	newpath",
	"	exch GET_BOX",
	"	8 FONT DO_FONT",
	"	/TMPX BOXX (10:00) stringwidth pop add 14 add def",
	"	/TMPY BOXY BOX_HEIGHT add 10 sub def",
	"	8 BOLD DO_FONT",
	"	TMPX 4 add TMPY 13 sub moveto TMPS cvs show",
	"	newpath TMPX 1 sub TMPY 14 sub moveto 0 21 rlineto stroke",
	"	newpath TMPX 0 add TMPY 3 add 1 0 180 arc stroke",
	"	newpath TMPX 0 add TMPY 0 sub 1 0 180 arc stroke",
	"	newpath TMPX 0 add TMPY 3 sub 1 0 180 arc stroke",
	"	newpath TMPX 0 add TMPY 6 sub 1 0 180 arc stroke",
	"	newpath TMPX 0 add TMPY 2 add 1 180 0 arc stroke",
	"	newpath TMPX 0 add TMPY 1 sub 1 180 0 arc stroke",
	"	newpath TMPX 0 add TMPY 4 sub 1 180 0 arc stroke",
	"	newpath TMPX 0 add TMPY 7 sub 1 180 0 arc stroke",
	"	newpath TMPX 1 add TMPY 2 add moveto 0 1 rlineto stroke",
	"	newpath TMPX 1 add TMPY 1 sub moveto 0 1 rlineto stroke",
	"	newpath TMPX 1 add TMPY 4 sub moveto 0 1 rlineto stroke",
	"	newpath TMPX 1 add TMPY 7 sub moveto 0 1 rlineto stroke",
	"	newpath TMPX 1 add TMPY 2 add moveto 3 3 rlineto stroke",
	"	newpath TMPX 1 add TMPY 1 sub moveto 3 3 rlineto stroke",
	"	newpath TMPX 1 add TMPY 4 sub moveto 3 3 rlineto stroke",
	"	newpath TMPX 1 add TMPY 7 sub moveto 3 3 rlineto stroke",
	"	newpath TMPX 2 sub TMPY 2 add 1 0 180 arc stroke",
	"	newpath TMPX 2 sub TMPY 1 sub 1 0 180 arc stroke",
	"	newpath TMPX 2 sub TMPY 4 sub 1 0 180 arc stroke",
	"	newpath TMPX 2 sub TMPY 1 add 1 180 0 arc stroke",
	"	newpath TMPX 2 sub TMPY 2 sub 1 180 0 arc stroke",
	"	newpath TMPX 2 sub TMPY 5 sub 1 180 0 arc stroke",
	"	newpath TMPX 3 sub TMPY 1 add moveto 0 1 rlineto stroke",
	"	newpath TMPX 3 sub TMPY 2 sub moveto 0 1 rlineto stroke",
	"	newpath TMPX 3 sub TMPY 5 sub moveto 0 1 rlineto stroke",
	"	newpath TMPX 3 sub TMPY 1 add moveto -3 3 rlineto stroke",
	"	newpath TMPX 3 sub TMPY 2 sub moveto -3 3 rlineto stroke",
	"	newpath TMPX 3 sub TMPY 5 sub moveto -3 3 rlineto stroke",
	"	} def",
	"/HAVDALAH {",
	"	exch GET_BOX",
	"	MDAY_SIZE 2 sub FONT DO_FONT",
	"	/TMPX BOXX BOX_WIDTH add (99) stringwidth pop sub 15 sub def",
	"	/TMPY BOXY BOX_HEIGHT add 20 sub def",
	"	8 FONT DO_FONT",
	"	dup stringwidth pop TMPX exch sub 2 sub TMPY 3 add moveto show",
	"	newpath",
	"	TMPX TMPY moveto 2 0 rlineto 0 2 rlineto 8 4 rlineto 0 3 rlineto",
	"	-2 0 rlineto 0 -2 rlineto -8 -4 rlineto",
	"	closepath stroke",
	"	newpath",
	"	TMPX 4 add TMPY moveto 2 0 rlineto 0 1 rlineto -1 2 rlineto",
	"	-1.5 -1 rlineto .5 -1 rlineto",
	"	closepath stroke",
	"	newpath",
	"	TMPX 6 add TMPY 9 add moveto -2 0 rlineto 0 -1 rlineto 1 -2 rlineto",
	"	1.5 1 rlineto -.5 1 rlineto",
	"	closepath stroke",
	"	newpath",
	"	TMPX 8 add TMPY moveto 2 0 rlineto 0 1 rlineto -1.5 3 rlineto",
	"	-1.5 -1 rlineto 1 -2 rlineto",
	"	closepath stroke",
	"	newpath",
	"	TMPX 2 add TMPY 9 add moveto -2 0 rlineto 0 -1 rlineto",
	"	1.5 -3 rlineto 1.5 1 rlineto -1 2 rlineto",
	"	closepath stroke",
	"	TMPX 1.5 add TMPY 12 add 1.5 0 360 arc fill",
	"	newpath TMPX TMPY 12 add moveto 1.5 5 rlineto 1.5 -5 rlineto",
	"	closepath fill",
	"	TMPX 5.5 add TMPY 12 add 1.5 0 360 arc fill",
	"	newpath TMPX  4 add TMPY 12 add moveto 1.5 5 rlineto 1.5 -5 rlineto",
	"	closepath fill",
	"	TMPX 9.5 add TMPY 12 add 1.5 0 360 arc fill",
	"	newpath TMPX  8 add TMPY 12 add moveto 1.5 5 rlineto 1.5 -5 rlineto",
	"	closepath fill",
	"	} def",
	"/SHABBAT  {",
	"	4 -1 roll",
	"	GET_BOX",
	"	8 FONT DO_FONT",
	"	BOXX 3 add BOXY 2  add JDAY_SIZE add 5 add moveto show",
	"	BOXX 3 add BOXY 10 add JDAY_SIZE add 5 add moveto show",
	"	10 BOLD DO_FONT",
	"	BOXX 3 add BOXY 18 add JDAY_SIZE add 5 add moveto show",
	"	} def",
	"/HOLIDAY {",
	"	MDAY_SIZE 2 sub BOLD DO_FONT",
	"	dup GET_BOX",
	"	newpath",
	"	BOXX BOX_WIDTH add BOXY BOX_HEIGHT add moveto",
	"	0 0 MDAY_SIZE 1 add sub rlineto",
	"	0 (99) stringwidth pop 3 add sub 0 rlineto",
	"	0 MDAY_SIZE 1 add rlineto",
	"	closepath",
	"	fill",
	"	TMPS cvs dup",
	"	stringwidth pop BOXX exch sub 3 sub BOX_WIDTH add",
	"	1 setgray",
	"	BOXY BOX_HEIGHT add MDAY_SIZE sub",
	"	moveto show",
	"	0 setgray",
	"	} def",
	"/BIG_ITEM",
	"	{",
	"	12 BOLD DO_FONT",
	"	exch GET_BOX",
	"	dup stringwidth pop",
	"	BOX_WIDTH exch sub 2 div BOXX add",
	"	BOXY BOX_HEIGHT add 14 sub MDAY_SIZE sub moveto",
	"	show",
	"	} def",
	"/BOLD_ITEM",
	"	{",
	"	10 BOLD DO_FONT",
	"	3 -1 roll GET_BOX",
	"	1 sub 11 mul BOXY BOX_HEIGHT add 14 sub MDAY_SIZE sub exch sub",
	"	BOXX 3 add exch moveto show",
	"	} def",
	"/ITEM",
	"	{",
	"	10 FONT DO_FONT",
	"	3 -1 roll GET_BOX",
	"	1 sub 11 mul BOXY BOX_HEIGHT add 14 sub MDAY_SIZE sub exch sub",
	"	BOXX 3 add exch moveto show",
	"	} def",
	"/JDATE",
	"	{",
	"	JDAY_SIZE FONT DO_FONT",
	"	exch GET_BOX",
	"	dup stringwidth pop 3 add BOXX exch sub BOX_WIDTH add BOXY 5 add",
	"	moveto show",
	"	} def",
	"/LOCALE {",
	"	10 FONT DO_FONT",
	"	MDAYS GET_BOX",
	"	dup stringwidth pop",
	"	(Candle Lighting times are for ) stringwidth pop add",
	"	11 72 mul exch sub 2 div BOXY 10 sub moveto",
	"	(Candle Lighting times are for ) show show",
	"	} def",
	"",
	"% draw lines",
	"",
	"newpath LEFT_SIDE TOP_LINE moveto CAL_WIDTH 0 rlineto stroke",
	"newpath LEFT_SIDE TOP_CAL  moveto CAL_WIDTH 0 rlineto stroke",
	"0 1 BOXES 1 add",
	"	{",
	"	newpath",
	"	BOX_HEIGHT mul BOTTOM_MARGIN add LEFT_SIDE exch",
	"	moveto CAL_WIDTH 0 rlineto stroke",
	"	} for",
	"0 1 8",
	"	{",
	"	newpath",
	"	BOX_WIDTH mul LEFT_SIDE add BOTTOM_MARGIN",
	"	moveto 0 CAL_HEIGHT rlineto stroke",
	"	} for",
	"",
	"% print month header",
	"",
	"MONTH_SIZE BOLD DO_FONT",
	"",
	"CAL_WIDTH 2 div",
	"MONTH stringwidth pop 2 div sub",
	"LEFT_SIDE add TOP_LINE 5 add moveto MONTH show",
	"LEFT_SIDE TOP_LINE 5 add moveto JYEAR show",
	"RIGHT_SIDE YEAR stringwidth pop sub TOP_LINE 5 add moveto YEAR show",
	"",
	"% print days of week header",
	"",
	"DAY_SIZE 2 sub FONT DO_FONT",
	"",
	"(SUNDAY) (MONDAY) (TUESDAY) (WEDNESDAY) (THURSDAY) (FRIDAY) (SATURDAY)",
	"1 1 7",
	"	{",
	"	7 exch sub BOX_WIDTH mul LEFT_SIDE add TOP_CAL 2 add moveto",
	"	dup stringwidth pop 2 div BOX_WIDTH 2 div exch sub 0 rmoveto show",
	"	} for",
	"",
	"% print days of month",
	"",
	"",
	"1 1 MDAYS",
	"	{",
	"	MDAY_SIZE 2 sub FONT DO_FONT",
	"	dup GET_BOX",
	"	TMPS cvs dup",
	"	stringwidth pop BOXX exch sub 3 sub BOX_WIDTH add",
	"	BOXY BOX_HEIGHT add MDAY_SIZE sub",
	"	moveto show",
	"	} for",
	"",
	NULL
};
char		 *ps_back[]			= {
	"showpage",
	NULL
};

#if defined(PROTOTYPES)
main(int argc, char **argv) {
#else
main(argc, argv) int argc; char **argv; {
#endif
	int current;

	parse_args(argc,argv);
	initialize(argc,argv);
	if (!flag_L)
		show_licence();
#ifdef BATCH
	print_out(NULL,NULL);
#else
	if (flag_q)
		print_out(NULL,NULL);
	else {
#if defined(XCURSES)
		if (!flag_I)
			xcal_setup();
#endif
		current = 7;
		while ((current = cur_alist_ask("Main Menu",main_menu,current,
				NULL,mprc_main,mprt_main)) != 7 || dirty)
			;
#if defined(XCURSES)
		if (!flag_I)
			xcal_remove();
#endif
		finalize();
	}
#endif
	exit(0);
}

#if defined(PROTOTYPES)
void initialize(int argc,char *argv[]) {
#else
void initialize(argc,argv) int argc;char **argv; {
#endif
	int		 ch;
	city_t		*cptr;
	int		 last;
	int		 loop;
	city_t		*new_city;
	ptable_t	*pptr;
	struct tm	*tinfo;
	time_t		 ttime;

	ttime = (int) time(&ttime);
	tinfo = (struct tm *) localtime(&ttime);
	if (current_month == -1)
		current_month = tinfo->tm_mon + 1;
	if (current_year == -1)
		current_year = tinfo->tm_year + 1900;
	if (current_month == 12) {
		current_month = 0;
		current_year++;
	}
	for (loop = 0;loop <= CHAG;loop++) {
		minyan[loop][SHAHARIT].word1 = 0;
		minyan[loop][SHAHARIT].word2 = 0;
		minyan[loop][MINCHA].word1 = 0;
		minyan[loop][MINCHA].word2 = 0;
		minyan[loop][MARIV].word1 = 0;
		minyan[loop][MARIV].word2 = 0;
	}

	for (loop = 1;loop <= 32;loop++) {
		day[loop].jmonth = NULL;
		day[loop].jday = 0;
		day[loop].jyear = 0;
		day[loop].shaharit.word1 = 0;
		day[loop].shaharit.word2 = 0;
		day[loop].mincha.word1 = 0;
		day[loop].mincha.word2 = 0;
		day[loop].mariv.word1 = 0;
		day[loop].mariv.word2 = 0;
		day[loop].edited = SET_PRAYER_DEFAULT;
		day[loop].autogenerated = SET_PRAYER_DEFAULT;
		day[loop].mitzvah = NULL;
		day[loop].holiday = 0;
		day[loop].candles.word1 = 0;
		day[loop].candles.word2 = 0;
		day[loop].shabbat = NULL;
		day[loop].chanukah = 0;
		day[loop].omer = 0;
		day[loop].info = NULL;
		day[loop].info_last = NULL;
	}

	InitHolidays();

	for (pptr = parse_table,last = -1;pptr->state != -1;pptr++)
		if (pptr->state > last)
			last = pptr->state;
	parse_entry = (ptable_t **)new(sizeof(ptable_t *) * (last + 2));
	for (pptr = parse_table,last = -1;pptr->state != -1;pptr++) {
		if (pptr->state != last) {
			parse_entry[pptr->state] = pptr;
			last = pptr->state;
		}
	}
	for (pptr = parse_table_time,last = -1;pptr->state != -1;pptr++)
		if (pptr->state > last)
			last = pptr->state;
	parse_entry_time = (ptable_t **)new(sizeof(ptable_t *) * (last + 2));
	for (pptr = parse_table_time,last = -1;pptr->state != -1;pptr++) {
		if (pptr->state != last) {
			parse_entry_time[pptr->state] = pptr;
			last = pptr->state;
		}
	}

	/* city info */
	for (cptr = cities_orig; cptr->name; cptr++) {
		new_city = findadd_city(cptr->name,NULL);
		new_city->latdeg = cptr->latdeg;
		new_city->latmin = cptr->latmin;
		new_city->latsec = cptr->latsec;
		new_city->longdeg = cptr->longdeg;
		new_city->longmin = cptr->longmin;
		new_city->longsec = cptr->longsec;
		new_city->tzone = cptr->tzone;
		new_city->dst_start_month = cptr->dst_start_month;
		new_city->dst_start_day = cptr->dst_start_day;
		new_city->dst_end_month = cptr->dst_end_month;
		new_city->dst_end_day = cptr->dst_end_day;
	}
	city = cities;

	set_month(current_month,current_year);

	if (flag_p)
		strcpy(print_file_name,flag_p);
	else
		strcpy(print_file_name,"calendar.ps");
	if (flag_s)
		strcpy(schedule_file_name,flag_s);
	else
		strcpy(schedule_file_name,"schedule");
	if (flag_t)
		strcpy(template_file_name,flag_t);
	else
		strcpy(template_file_name,"template");

	fprintf(stderr,"Reading template file '%s'\n\n",template_file_name);
	sleep(1);
	tdirty = NO;
	if (read_file(template_file_name,NO)) {
	        fprintf(stderr,"\nHit return to continue, ^d to stop\n");
		while (ch = getchar(),ch != EOF && ch != '\n')
			;
		if (ch == EOF)
			exit(1);
		fputc('\n',stderr);
	}

	if (flag_o) {
		strcpy(save_file_name,flag_o);
		fprintf(stderr,"Reading input file '%s'\n\n",save_file_name);
		sleep(2);
		if (read_file(save_file_name,NO)) {
			fprintf(stderr,
				"\nHit return to continue, ^d to stop\n");
			while (ch = getchar(),ch != EOF && ch != '\n')
				;
			if (ch == EOF)
				exit(1);
			fputc('\n',stderr);
		}
	}
	else
		strcpy(save_file_name,"savefile");

	if (flag_c) {
		for (city = cities,city_number = 1;
				 city && casecmp(city->name,flag_c) != 0;
				 city = city->next,city_number++)
				 ;
		if (!city) {
			fprintf(stderr,
	"City '%s' not defined, add it to your template file\n",flag_c);
			exit(1);
		}
	}

#ifndef BATCH
	if (!flag_q) {
		/* month menu */
		for (loop = 0;loop < 12;loop++) {
			month_menu = cur_slist_add(month_menu,month[loop]);
		}

		/* main menu */
		main_menu = NULL;
		main_menu = cur_alist_add(main_menu,TYPE_MAIN_MONTH,NULL);
		main_menu = cur_alist_add(main_menu,TYPE_MAIN_EDIT,NULL);
		main_menu = cur_alist_add(main_menu,TYPE_MAIN_DATA,NULL);
		main_menu = cur_alist_add(main_menu,TYPE_MAIN_SAVE,NULL);
		main_menu = cur_alist_add(main_menu,TYPE_MAIN_READ,NULL);
		main_menu = cur_alist_add(main_menu,TYPE_MAIN_PRINT,NULL);
		main_menu = cur_alist_add(main_menu,TYPE_MAIN_QUIT,NULL);

		cur_start(argc,argv);
	}
#endif
}
