/*
#
#   hcal version 1.0 - postscript hebrew calendar generator
#   copyright 1994,1995 - Steven Weintraub
#
#   This program is created and distribed by Steven Weintraub.  It
#   can be freely distributed without permission as long as this
#   head is retained in all files it appears and the LICENCE file
#   accompanies it.
#
*/

#if defined(PROTOTYPES)
extern int		add_city	(void);
extern int		add_item	(void);
extern int		add_jdate	(int);
extern int		add_misc	(void);
extern int		add_mitzvah	(void);
extern int		add_shabbat	(void);
extern void		add_to_day	(day_data_t *,info_t *);
extern int		break_up	(int,time_info_t *,char *,int,char *);
extern int		casecmp		(char *,char*);
extern void		cmd_data	(void);
extern void		cmd_edit  	(void);
extern void		cmd_month	(void);
extern void		cmd_print	(void);
extern void		cmd_quit	(void);
extern void		cmd_read	(void);
extern void		cmd_save	(void);
extern int		day_of_week	(int,int,int);
extern void		direction	(void);
extern void		do_minyan_day	(int,time_info_t *,time_info_t *,time_info_t *);
extern void		do_minyan_rosh	(time_info_t *,time_info_t *,time_info_t *);
extern void		do_minyan_chag	(time_info_t *,time_info_t *,time_info_t *);
extern void		do_minyan_week	(int,time_info_t *,time_info_t *,time_info_t *);
extern void		do_date		(int,int,int,day_data_t *);
extern int		edit_city	(city_t *);
extern int		edit_item	(int,info_t *);
extern int		edit_jdate	(int,day_data_t *);
extern void		edit_minyan	(void);
extern int		edit_mitzvah	(int,day_data_t *);
extern int		edit_shabbat	(int,day_data_t *);
extern void		finalize	(void);
extern city_t		*findadd_city	(char *,int *);
extern char		*format_time	(int,time_info_t *,int);
extern void		free_month	(void);
extern FILE		*get_file	(char *,char *,char *);
extern void		get_time	(cur_mlist_t *);
extern int		get_time_normal	(time_info_t *,char *);
extern int		get_time_zamin	(int,char *,time_info_t *);
extern int		get_time_zday	(int,char *,time_info_t *);
extern int		get_token	(char *);
extern void		InitHolidays	(void);
extern void		initialize	(int,char **);
extern int		is_dot		(char *);
extern int		is_dst		(int,int);
extern int		is_int		(char *);
extern int		is_jmonth	(char *);
extern int		is_latlong	(char *,int,int);
extern int		is_month	(char *);
extern int		is_time		(char *,int,time_info_t *);
extern char		*items_fit	(time_info_t *,char *,int,int);
extern int		julian_date	(int,int,int);
extern char		*mk_cal_info	(char *,char *);
extern cur_slist_t	*mk_items	(char *);
extern cur_mlist_t	*mk_menu		(char **);
extern char		*mk_string	(char *);
extern void		mlist_set_time	(int,cur_mlist_t *,time_info_t *);
extern void		modify_candles	(int);
extern void		month_day	(int,int,int *,int *);
extern int 		mprc_delete	(int,void *);
extern int 		mprc_edit	(int,int,void *);
extern int 		mprc_main	(int,int,void *);
extern int 		mprc_minyan	(int,int,void *);
extern int 		mprc_misc	(int,int,void *);
extern char		*mprt_edit	(int,void *,char *);
extern char		*mprt_main	(int,void *,char *);
extern char		*mprt_minyan	(int,void *,char *);
extern char		*mprt_misc	(int,void *,char *);
extern int		next_char	(void);
extern void		*new		(int);
extern char		*param_arg	(char **,int *,char **,int);
extern int		parse_action	(ptable_t *,char *);
extern void		parse_args	(int,char **);
extern int 		parse_error	(char *);
extern void		parse_init	(void);
extern void		print_city	(FILE *,city_t *);
extern void		print_minyan	(FILE *,int);
extern void		print_out	(FILE *,FILE *);
extern float		pstrlen		(char *,int);
extern void 		read_calendar	(void);
extern int 		read_file	(char *,int);
extern void		replace_char	(void);
extern void		replace_token	(void);
extern void		report_error	(char *);
extern void		set_month	(int,int);
extern void		show_licence	(void);
extern int		size_verify	(cur_mlist_t *);
extern char		*stradd		(char *,char *,char *);
extern int		suntime		(int,int);
#ifdef XCURSES
extern int		xcal_draw	(void);
extern void		xcal_remove	(void);
extern void		xcal_setup	(void);
#endif
#else /* NO PROTOTYPES */
extern int		add_city	();
extern int		add_item	();
extern int		add_jdate	();
extern int		add_misc	();
extern int		add_mitzvah	();
extern int		add_shabbat	();
extern void		add_to_day	();
extern int		break_up	();
extern int		casecmp		();
extern void		cmd_data	();
extern void		cmd_edit  	();
extern void		cmd_month	();
extern void		cmd_print	();
extern void		cmd_quit	();
extern void		cmd_read	();
extern void		cmd_save	();
extern int		day_of_week	();
extern void		direction	();
extern void		do_minyan_day	();
extern void		do_minyan_rosh	();
extern void		do_minyan_chag	();
extern void		do_minyan_week	();
extern void		do_date		();
extern int		edit_city	();
extern int		edit_item	();
extern int		edit_jdate	();
extern void		edit_minyan	();
extern int		edit_mitzvah	();
extern int		edit_shabbat	();
extern void		finalize	();
extern city_t		*findadd_city	();
extern char		*format_time	();
extern void		free_month	();
extern FILE		*get_file	();
extern void		get_time	();
extern int		get_time_normal	();
extern int		get_time_zamin	();
extern int		get_time_zday	();
extern int		get_token	();
extern void		InitHolidays	();
extern void		initialize	();
extern int		is_dot		();
extern int		is_dst		();
extern int		is_int		();
extern int		is_jmonth	();
extern int		is_latlong	();
extern int		is_month	();
extern int		is_time		();
extern char		*items_fit	();
extern int		julian_date	();
extern char		*mk_cal_info	();
extern cur_slist_t	*mk_items	();
extern cur_mlist_t	*mk_menu	();
extern char		*mk_string	();
extern void		mlist_set_time	();
extern void		modify_candles	();
extern void		month_day	();
extern int 		mprc_delete	();
extern int 		mprc_edit	();
extern int 		mprc_main	();
extern int 		mprc_minyan	();
extern int 		mprc_misc	();
extern char		*mprt_edit	();
extern char		*mprt_main	();
extern char		*mprt_minyan	();
extern char		*mprt_misc	();
extern int		next_char	();
extern void		*new		();
extern char		*param_arg	();
extern int		parse_action	();
extern void		parse_args	();
extern int 		parse_error	();
extern void		parse_init	();
extern void		print_city	();
extern void		print_minyan	();
extern void		print_out	();
extern float		pstrlen		();
extern void 		read_calendar	();
extern int 		read_file	();
extern void		replace_char	();
extern void		replace_token	();
extern void		report_error	();
extern void		set_month	();
extern void		show_licence	();
extern int		size_verify	();
extern char		*stradd		();
extern int		suntime		();
#ifdef XCURSES
extern int		xcal_draw	();
extern void		xcal_remove	();
extern void		xcal_setup	();
#endif
#endif
