static char version[] =
"hcal version 1.0 - postscript hebrew calendar generator\n\n\
copyright 1994,1995 - Steven Weintraub";

/*
 
    hcal version 1.0 - postscript hebrew calendar generator
    copyright 1994,1995 - Steven Weintraub
 
    This program is created and distribed by Steven Weintraub. It
    can be freely distributed without permission as long as this
    head is retained in all files it appears and the LICENCE file
    accompanies it.
 
*/

#include "hcal.h"
/* #define PSTATE */

ptable_t parse_table_time[] = {
 /* state,	TOKEN_token,	*match,		act nxt	enxt param;  */
  {  0,	TOKEN_INT,	NULL,		 1, 1, 0, 0  },
  {  0,	TOKEN_SPACE,	NULL,		 0, 0, 0, 0  },
  {  0,	TOKEN_MATCH,	"Candles",	 2,30,-1,TIME_TYPE_CANDLELIGHTING  },
  {  0,	TOKEN_MATCH,	"Candlelighting",2,30,-1,TIME_TYPE_CANDLELIGHTING  },
  {  0,	TOKEN_MATCH,	"Noon",		 2,-1,-1,TIME_TYPE_NORMAL|12*60  },
  {  0,	TOKEN_MATCH,	"None",		 2,-1,-1,TIME_TYPE_NONE },
  {  0,	TOKEN_MATCH,	"Halachic",	 2,21, 0, 0  },
  {  0,	TOKEN_MATCH,	"Midday",	 2,30,-1,TIME_TYPE_HALACHIC_MIDDAY  },
  {  0,	TOKEN_MATCH,	"Midnight",	 2,-1,-1,TIME_TYPE_MIDNIGHT  },
  {  0,	TOKEN_MATCH,	"Mincha",	 2,22, 0, 0  },
  {  0,	TOKEN_MATCH,	"Plug",		 2,23,-1,TIME_TYPE_PLUG_HAMINCHA  },
  {  0,	TOKEN_MATCH,	"Rise",		 2,30,-1,TIME_TYPE_SUNRISE  },
  {  0,	TOKEN_MATCH,	"Set",		 2,30,-1,TIME_TYPE_SUNSET  },
  {  0,	TOKEN_MATCH,	"Sunrise",	 2,30,-1,TIME_TYPE_SUNRISE  },
  {  0,	TOKEN_MATCH,	"Sunset",	 2,30,-1,TIME_TYPE_SUNSET  },
  {  0,	TOKEN_MATCH,	"Three",	 2,24,-1,TIME_TYPE_THREE_STARS  },
  {  0,	TOKEN_MATCH,	"Zaman",	 2,25,-1,TIME_TYPE_ZMAN_TEFILA  },
  {  0,	TOKEN_MATCH,	"Zamin",	 2,25,-1,TIME_TYPE_ZMAN_TEFILA  },
  {  0,	TOKEN_MATCH,	"Z'man",	 2,25,-1,TIME_TYPE_ZMAN_TEFILA  },
  {  0,	TOKEN_MATCH,	"Z'min",	 2,25,-1,TIME_TYPE_ZMAN_TEFILA  },
  {  1,	TOKEN_CHAR,	":",		 0, 2, 0, 0  },
  {  1,	TOKEN_SPACE,	NULL,		 0, 3, 0, 0  },
  {  1,	TOKEN_CHAR,	"P",		 4, 4,-1, 0  },
  {  1,	TOKEN_CHAR,	"A",		 0, 4,-1, 0  },
  {  1,	TOKEN_MATCH,	"DAY",		 2,10,-1,TIME_TYPE_ZAMIN_DAY  },
  {  1,	TOKEN_MATCH,	"DAYTIME",	 2,10,-1,TIME_TYPE_ZAMIN_DAY  },
  {  1,	TOKEN_MATCH,	"NIGHT",	 2,10,-1,TIME_TYPE_ZAMIN_NIGHT  },
  {  1,	TOKEN_MATCH,	"NIGHTTIME",	 2,10,-1,TIME_TYPE_ZAMIN_NIGHT  },
  {  1,	TOKEN_MATCH,	"Z'MIN",	 0,11, 0, 0  },
  {  1,	TOKEN_MATCH,	"Z'MAN",	 0,11, 0, 0  },
  {  1,	TOKEN_MATCH,	"ZAMAN",	 0,11, 0, 0  },
  {  1,	TOKEN_MATCH,	"ZAMIN",	 0,11, 0, 0  },
  {  1,	TOKEN_CHAR,	"D",		 2,12,-1,TIME_TYPE_ZAMIN_DAY  },
  {  1,	TOKEN_CHAR,	"N",		 2,12,-1,TIME_TYPE_ZAMIN_NIGHT  },
  {  1,	TOKEN_CHAR,	"Z",		 0,15, 0, 0  },
  {  2,	TOKEN_INT,	NULL,		 3, 3, 0, 0  },
  {  2,	TOKEN_SPACE,	NULL,		 0, 3, 0, 0  },
  {  2,	TOKEN_CHAR,	"P",		 0, 4,-1, 0  },
  {  2,	TOKEN_CHAR,	"A",		 0, 4,-1, 0  },
  {  2,	TOKEN_MATCH,	"DAY",		 2,10,-1,TIME_TYPE_ZAMIN_DAY  },
  {  2,	TOKEN_MATCH,	"DAYTIME",	 2,10,-1,TIME_TYPE_ZAMIN_DAY  },
  {  2,	TOKEN_MATCH,	"NIGHT",	 2,10,-1,TIME_TYPE_ZAMIN_NIGHT  },
  {  2,	TOKEN_MATCH,	"NIGHTTIME",	 2,10,-1,TIME_TYPE_ZAMIN_NIGHT  },
  {  2,	TOKEN_MATCH,	"Z'MIN",	 0,11, 0, 0  },
  {  2,	TOKEN_MATCH,	"Z'MAN",	 0,11, 0, 0  },
  {  2,	TOKEN_MATCH,	"ZAMAN",	 0,11, 0, 0  },
  {  2,	TOKEN_MATCH,	"ZAMIN",	 0,11, 0, 0  },
  {  2,	TOKEN_CHAR,	"D",		 2,12,-1,TIME_TYPE_ZAMIN_DAY  },
  {  2,	TOKEN_CHAR,	"N",		 2,12,-1,TIME_TYPE_ZAMIN_NIGHT  },
  {  2,	TOKEN_CHAR,	"Z",		 0,15, 0, 0  },
  {  3,	TOKEN_SPACE,	NULL,		 0, 3, 0, 0  },
  {  3,	TOKEN_CHAR,	"P",		 4, 4,-1, 0  },
  {  3,	TOKEN_CHAR,	"A",		 0, 4,-1, 0  },
  {  3,	TOKEN_MATCH,	"DAY",		 2,10,-1,TIME_TYPE_ZAMIN_DAY  },
  {  3,	TOKEN_MATCH,	"DAYTIME",	 2,10,-1,TIME_TYPE_ZAMIN_DAY  },
  {  3,	TOKEN_MATCH,	"NIGHT",	 2,10,-1,TIME_TYPE_ZAMIN_NIGHT  },
  {  3,	TOKEN_MATCH,	"NIGHTTIME",	 2,10,-1,TIME_TYPE_ZAMIN_NIGHT  },
  {  3,	TOKEN_MATCH,	"Z'MIN",	 0,11, 0, 0  },
  {  3,	TOKEN_MATCH,	"Z'MAN",	 0,11, 0, 0  },
  {  3,	TOKEN_MATCH,	"ZAMAN",	 0,11, 0, 0  },
  {  3,	TOKEN_MATCH,	"ZAMIN",	 0,11, 0, 0  },
  {  3,	TOKEN_CHAR,	"D",		 2,12,-1,TIME_TYPE_ZAMIN_DAY  },
  {  3,	TOKEN_CHAR,	"N",		 2,12,-1,TIME_TYPE_ZAMIN_NIGHT  },
  {  3,	TOKEN_CHAR,	"Z",		 0,15, 0, 0  },
  {  4,	TOKEN_SPACE,	NULL,		 0, 4, 0, 0  },
  {  4,	TOKEN_CHAR,	".",		 0, 5,-1, 0  },
  {  4,	TOKEN_CHAR,	"M",		 0, 6,-1, 0  },
  {  5,	TOKEN_SPACE,	NULL,		 0, 5, 0, 0  },
  {  5,	TOKEN_CHAR,	"M",		 0, 6,-1, 0  },
  {  6,	TOKEN_SPACE,	NULL,		 0, 6, 0, 0  },
  {  6,	TOKEN_CHAR,	".",		 0,-1,-1, 0  },

  { 10,	TOKEN_SPACE,	NULL,		 0,10, 0, 0  },
  { 10,	TOKEN_MATCH,	"Z'MIN",	 0,30,-1, 0  },
  { 10,	TOKEN_MATCH,	"Z'MAN",	 0,30,-1, 0  },
  { 10,	TOKEN_MATCH,	"ZAMAN",	 0,30,-1, 0  },
  { 10,	TOKEN_MATCH,	"ZAMIN",	 0,30,-1, 0  },
  { 10,	TOKEN_MATCH,	"ROUND",	 7,34, 0, 0  },
  { 10,	TOKEN_MATCH,	"ROUNDED",	 7,34, 0, 0  },
  { 10, TOKEN_MATCH,	"MIN",		 8,40, 0, 0  },
  { 10, TOKEN_MATCH,	"MAX",		 9,40, 0, 0  },
  { 10, TOKEN_MATCH,	"MINIMUN",	 8,40, 0, 0  },
  { 10, TOKEN_MATCH,	"MAXIMUN",	 9,40, 0, 0  },
  { 11,	TOKEN_MATCH,	"DAY",		 2,30,-1,TIME_TYPE_ZAMIN_DAY  },
  { 11,	TOKEN_MATCH,	"DAYTIME",	 2,30,-1,TIME_TYPE_ZAMIN_DAY  },
  { 11,	TOKEN_MATCH,	"NIGHT",	 2,30,-1,TIME_TYPE_ZAMIN_NIGHT  },
  { 11,	TOKEN_MATCH,	"NIGHTTIME",	 2,30,-1,TIME_TYPE_ZAMIN_NIGHT  },
  { 12,	TOKEN_SPACE,	NULL,		 0,12, 0, 0  },
  { 12,	TOKEN_CHAR,	".",		 0,13,-1, 0  },
  { 12,	TOKEN_CHAR,	"Z",		 0,14,-1, 0  },
  { 12,	TOKEN_MATCH,	"ROUND",	 7,34, 0, 0  },
  { 12,	TOKEN_MATCH,	"ROUNDED",	 7,34, 0, 0  },
  { 12, TOKEN_MATCH,	"MIN",		 8,40, 0, 0  },
  { 12, TOKEN_MATCH,	"MAX",		 9,40, 0, 0  },
  { 12, TOKEN_MATCH,	"MINIMUN",	 8,40, 0, 0  },
  { 12, TOKEN_MATCH,	"MAXIMUN",	 9,40, 0, 0  },
  { 13,	TOKEN_SPACE,	NULL,		 0,13, 0, 0  },
  { 13,	TOKEN_CHAR,	"Z",		 0,14,-1, 0  },
  { 13,	TOKEN_MATCH,	"ROUND",	 7,34, 0, 0  },
  { 13,	TOKEN_MATCH,	"ROUNDED",	 7,34, 0, 0  },
  { 13, TOKEN_MATCH,	"MIN",		 8,40, 0, 0  },
  { 13, TOKEN_MATCH,	"MAX",		 9,40, 0, 0  },
  { 13, TOKEN_MATCH,	"MINIMUN",	 8,40, 0, 0  },
  { 13, TOKEN_MATCH,	"MAXIMUN",	 9,40, 0, 0  },
  { 14,	TOKEN_SPACE,	NULL,		 0,14, 0, 0  },
  { 14,	TOKEN_CHAR,	".",		 0,30,-1, 0  },
  { 14,	TOKEN_MATCH,	"ROUND",	 7,34, 0, 0  },
  { 14,	TOKEN_MATCH,	"ROUNDED",	 7,34, 0, 0  },
  { 14, TOKEN_MATCH,	"MIN",		 8,40, 0, 0  },
  { 14, TOKEN_MATCH,	"MAX",		 9,40, 0, 0  },
  { 14, TOKEN_MATCH,	"MINIMUN",	 8,40, 0, 0  },
  { 14, TOKEN_MATCH,	"MAXIMUN",	 9,40, 0, 0  },
  { 15,	TOKEN_SPACE,	NULL,		 0,15, 0, 0  },
  { 15,	TOKEN_CHAR,	".",		 0,16, 0, 0  },
  { 15,	TOKEN_CHAR,	"D",		 2,17,-1,TIME_TYPE_ZAMIN_DAY  },
  { 15,	TOKEN_CHAR,	"N",		 2,17,-1,TIME_TYPE_ZAMIN_NIGHT  },
  { 16,	TOKEN_SPACE,	NULL,		 0,16, 0, 0  },
  { 16,	TOKEN_CHAR,	"D",		 2,17,-1,TIME_TYPE_ZAMIN_DAY  },
  { 16,	TOKEN_CHAR,	"N",		 2,17,-1,TIME_TYPE_ZAMIN_NIGHT  },
  { 17,	TOKEN_SPACE,	NULL,		 0,15, 0, 0  },
  { 17,	TOKEN_CHAR,	".",		 0,33, 0, 0  },
  { 17,	TOKEN_MATCH,	"ROUND",	 7,34, 0, 0  },
  { 17,	TOKEN_MATCH,	"ROUNDED",	 7,34, 0, 0  },
  { 17, TOKEN_MATCH,	"MIN",		 8,40, 0, 0  },
  { 17, TOKEN_MATCH,	"MAX",		 9,40, 0, 0  },
  { 17, TOKEN_MATCH,	"MINIMUN",	 8,40, 0, 0  },
  { 17, TOKEN_MATCH,	"MAXIMUN",	 9,40, 0, 0  },

  { 21,	TOKEN_SPACE,	NULL,		 0,21, 0, 0  },
  { 21,	TOKEN_MATCH,	"Midday",	 2,30,-1,TIME_TYPE_HALACHIC_MIDDAY  },
  { 21,	TOKEN_MATCH,	"Midnight",	 2,30,-1,TIME_TYPE_HALACHIC_MIDNIGHT  },
  { 22,	TOKEN_SPACE,	NULL,		 0,22, 0, 0  },
  { 22,	TOKEN_MATCH,	"Gadolah",	 2,30,-1,TIME_TYPE_MINCHA_GADOLA  },
  { 22,	TOKEN_MATCH,	"Katanah",	 2,30,-1,TIME_TYPE_MINCHA_KATANA  },
  { 23,	TOKEN_SPACE,	NULL,		 0,23, 0, 0  },
  { 23,	TOKEN_MATCH,	"HaMincha",	 2,30,-1, 0  },
  { 24,	TOKEN_SPACE,	NULL,		 0,24, 0, 0  },
  { 24,	TOKEN_MATCH,	"Stars",	 2,30,-1, 0  },
  { 25,	TOKEN_SPACE,	NULL,		 0,25, 0, 0  },
  { 25,	TOKEN_MATCH,	"Tefilah",	 2,30,-1, 0  },
  { 25,	TOKEN_MATCH,	"Tefila",	 2,30,-1, 0  },

  { 30,	TOKEN_SPACE,	NULL,		 0,30, 0, 0  },
  { 30,	TOKEN_CHAR,	"+",		 0,31, 0, 0  },
  { 30,	TOKEN_CHAR,	"-",		 2,31, 0,TIME_INCR_SIGN_MASK  },
  { 30,	TOKEN_MATCH,	"ROUND",	 7,34, 0, 0  },
  { 30,	TOKEN_MATCH,	"ROUNDED",	 7,34, 0, 0  },
  { 30, TOKEN_MATCH,	"MIN",		 8,40, 0, 0  },
  { 30, TOKEN_MATCH,	"MAX",		 9,40, 0, 0  },
  { 30, TOKEN_MATCH,	"MINIMUN",	 8,40, 0, 0  },
  { 30, TOKEN_MATCH,	"MAXIMUN",	 9,40, 0, 0  },
  { 31,	TOKEN_SPACE,	NULL,		 0,31, 0, 0  },
  { 31,	TOKEN_INT,	NULL,		 5,32,-1, 0  },
  { 32,	TOKEN_SPACE,	NULL,		 0,32, 0, 0  },
  { 32,	TOKEN_MATCH,	"MIN",		 0,33,-1, 0  },
  { 32,	TOKEN_MATCH,	"MINS",		 0,33,-1, 0  },
  { 32,	TOKEN_MATCH,	"MINUTE",	 0,33,-1, 0  },
  { 32,	TOKEN_MATCH,	"MINUTES",	 0,33,-1, 0  },
  { 32,	TOKEN_MATCH,	"ROUND",	 7,34, 0, 0  },
  { 32,	TOKEN_MATCH,	"ROUNDED",	 7,34, 0, 0  },
  { 32, TOKEN_MATCH,	"MIN",		 8,40, 0, 0  },
  { 32, TOKEN_MATCH,	"MAX",		 9,40, 0, 0  },
  { 32, TOKEN_MATCH,	"MINIMUN",	 8,40, 0, 0  },
  { 32, TOKEN_MATCH,	"MAXIMUN",	 9,40, 0, 0  },
  { 33,	TOKEN_SPACE,	NULL,		 0,33, 0, 0  },
  { 33,	TOKEN_MATCH,	"ROUND",	 7,34, 0, 0  },
  { 33,	TOKEN_MATCH,	"ROUNDED",	 7,34, 0, 0  },
  { 33, TOKEN_MATCH,	"MIN",		 8,40, 0, 0  },
  { 33, TOKEN_MATCH,	"MAX",		 9,40, 0, 0  },
  { 33, TOKEN_MATCH,	"MINIMUN",	 8,40, 0, 0  },
  { 33, TOKEN_MATCH,	"MAXIMUN",	 9,40, 0, 0  },
  { 34,	TOKEN_SPACE,	NULL,		 0,34, 0, 0  },
  { 34,	TOKEN_CHAR,	"+",		 0,35, 0, 0  },
  { 34,	TOKEN_MATCH,	"UP",		 0,35, 0, 0  },
  { 34,	TOKEN_CHAR,	"-",		 2,35, 0,TIME_ROUND_SIGN_MASK  },
  { 34,	TOKEN_MATCH,	"DOWN",		 2,35, 0,TIME_ROUND_SIGN_MASK  },
  { 35,	TOKEN_SPACE,	NULL,		 0,35, 0, 0  },
  { 35,	TOKEN_INT,	NULL,		 6,36,-1, 0  },
  { 36,	TOKEN_SPACE,	NULL,		 0,36,-1, 0  },
  { 36,	TOKEN_MATCH,	"MIN",		 0,33,-1, 0  },
  { 36,	TOKEN_MATCH,	"MINS",		 0,33,-1, 0  },
  { 36,	TOKEN_MATCH,	"MINUTE",	 0,33,-1, 0  },
  { 36,	TOKEN_MATCH,	"MINUTES",	 0,33,-1, 0  },

  { 40,	TOKEN_INT,	NULL,		 1,41, 0, 0  },
  { 40,	TOKEN_SPACE,	NULL,		 0,40, 0, 0  },
  { 41,	TOKEN_CHAR,	":",		 0,42, 0, 0  },
  { 41,	TOKEN_SPACE,	NULL,		 0,43, 0, 0  },
  { 41,	TOKEN_CHAR,	"P",		 4,44,-1, 0  },
  { 41,	TOKEN_CHAR,	"A",		 0,44,-1, 0  },
  { 42,	TOKEN_INT,	NULL,		 3,43, 0, 0  },
  { 42,	TOKEN_SPACE,	NULL,		 0,43, 0, 0  },
  { 42,	TOKEN_CHAR,	"P",		 0,44,-1, 0  },
  { 42,	TOKEN_CHAR,	"A",		 0,44,-1, 0  },
  { 43,	TOKEN_SPACE,	NULL,		 0,43, 0, 0  },
  { 43,	TOKEN_CHAR,	"P",		 4,44,-1, 0  },
  { 43,	TOKEN_CHAR,	"A",		 0,44,-1, 0  },
  { 44,	TOKEN_SPACE,	NULL,		 0,44, 0, 0  },
  { 44,	TOKEN_CHAR,	".",		 0,45,-1, 0  },
  { 44, TOKEN_MATCH,	"MIN",		 8,40, 0, 0  },
  { 44, TOKEN_MATCH,	"MAX",		 9,40, 0, 0  },
  { 44, TOKEN_MATCH,	"MINIMUN",	 8,40, 0, 0  },
  { 44, TOKEN_MATCH,	"MAXIMUN",	 9,40, 0, 0  },
  { 44,	TOKEN_CHAR,	"M",		 0,46,-1, 0  },
  { 45,	TOKEN_SPACE,	NULL,		 0,45, 0, 0  },
  { 45, TOKEN_MATCH,	"MIN",		 8,40, 0, 0  },
  { 45, TOKEN_MATCH,	"MAX",		 9,40, 0, 0  },
  { 45, TOKEN_MATCH,	"MINIMUN",	 8,40, 0, 0  },
  { 45, TOKEN_MATCH,	"MAXIMUN",	 9,40, 0, 0  },
  { 45,	TOKEN_CHAR,	"M",		 0,46,-1, 0  },
  { 46,	TOKEN_SPACE,	NULL,		 0,46, 0, 0  },
  { 46,	TOKEN_CHAR,	".",		 0,33,-1, 0  },
  { 46, TOKEN_MATCH,	"MIN",		 8,40, 0, 0  },
  { 46, TOKEN_MATCH,	"MAX",		 9,40, 0, 0  },
  { 46, TOKEN_MATCH,	"MINIMUN",	 8,40, 0, 0  },
  { 46, TOKEN_MATCH,	"MAXIMUN",	 9,40, 0, 0  },

  { -1, 0,		NULL,		 0, 0, 0, 0  }};


#if defined(PROTOTYPES)
int is_time(char *string,int have_file,time_info_t *times) {
#else
int is_time(string,have_file,times)
char *string;int have_file; time_info_t *times;
{
#endif
	int		 ch;
	int		 char_count;
	int		 have_none = NO;
	int		 mask;
	int		 more;
	int		 save_ch;
	char		*save_eot;
	int		*save_read_place;
	char		*send;
	char		*sptr;
	char		*sptr2;
	int		 state;
	int		 stime;
	ptable_t	*table;
	int		 time;
	int		*ctime;
	int		 val;
	int		 have_round;
	int		 have_lower;
	int		 have_upper;
	int		 lower;
	int		 upper;

	if (!string || !*string)
		return 0;
	state = 0;
	time = 0;
	ctime = &time;
	mask = 0;
	sptr = string;
	send = NULL;
	save_read_place = read_place;
	save_eot = NULL;
	char_count = strlen(string);
	have_round = NO;
	have_lower = NO;
	have_upper = NO;
	lower = 0;
	upper = 0;
	if (isalpha(*sptr))
		{
		for (send = sptr;isalpha(*send);send++)
			;
		save_ch = *send;
		*send = '\0';
		}
	else
		send = NULL;
	more = YES;
	while (state >= 0 && more) {
#ifdef PSTATE
		fprintf(stderr,"\nstate = %d\n",state);
		fprintf(stderr,"string = >%s<\n",string);
		fprintf(stderr,"stream = >%s<\n",sptr);
		fprintf(stderr,"return = %8.8x, mask = %8.8x, time = %d\n",time | mask,mask,*ctime);
#endif
		for (table = parse_entry_time[state];
			table->state == state &&
				!((table->token == TOKEN_MATCH &&
				       casecmp(sptr,table->match) == 0) ||
				  (table->token == TOKEN_INT && 
				      isdigit(*sptr)) ||
				  (table->token == TOKEN_CHAR && 
				      toupper(*sptr) == *table->match) ||
				  (table->token == TOKEN_SPACE && 
				      isspace(*sptr))
				 );
			table++)
#ifdef PSTATE
			{
			fprintf(stderr,"table->state = %3d\n",table->state);
			fprintf(stderr,"table->token = %3d\n",table->token);
			fprintf(stderr,"table->match = %3s\n",table->match);
			fprintf(stderr,"table->next = %3d\n",table->next);
			fprintf(stderr,"table->enext = %3d\n",table->enext);
			fprintf(stderr,"table->action = %3d\n",table->action);
			}
#endif
			;
#ifdef PSTATE
		fprintf(stderr,"end->state = %3d\n",table->state);
		fprintf(stderr,"end->token = %3d\n",table->token);
		fprintf(stderr,"end->match = %3s\n",table->match);
		fprintf(stderr,"end->next = %3d\n",table->next);
		fprintf(stderr,"end->enext = %3d\n",table->enext);
		fprintf(stderr,"end->action = %3d\n",table->action);
#endif
		if (table->state == state) {
			if (send)
				*send = save_ch;
			switch (table->token) {
				case TOKEN_INT:
					val = 0;
					while (isdigit(*sptr)) {
						val = val * 10 + *sptr - '0';
						sptr++;
					}
#ifdef PSTATE
					fprintf(stderr,"value = %d\n",val);
#endif
					break;
				case TOKEN_CHAR:
					sptr++;
					break;
				case TOKEN_SPACE:
					while (isspace(*sptr))
						sptr++;
					break;
				case TOKEN_MATCH:
					sptr = send;
					break;
			}
			state = table->next;
			if (table->enext) {
				save_eot = sptr;
			}
			if (!*sptr) {
				if (have_file) {
					sptr2 = sptr;
					do {
						ch = next_char();
						*sptr2 = ch;
						sptr2++;
					} while (isspace(ch));
					while (ch != EOF && !isspace(ch)) {
						ch = next_char();
						*sptr2 = ch;
						sptr2++;
					}
					replace_char();
					sptr2--;
					*sptr2 = '\0';
				} else if (table->enext) {
					state = -1;
				} else {
					state = -2;
				}
			}
			if (isalpha(*sptr))
				{
				for (send = sptr;isalpha(*send);send++)
					;
				save_ch = *send;
				*send = '\0';
				}
			else
				send = NULL;
			switch (table->action) {
				case 1:
					if (val > 12) {
						time = 0;
						state = -2;
					}
					else if (val != 12)
						*ctime = val * 60;
					break;
				case 2:
					mask |= table->param;
					break;
				case 3:
					if (val > 59) {
						state = -2;
						time = 0;
					} else
						*ctime += val;
					break;
				case 4:
					*ctime += 12 * 60;
					break;
				case 5:
					if (val <= 240) {
						mask |= val;
					} else {
						state = -2;
					}
					break;
				case 6:
					if (val > 60)
						state = -2;
					else
						mask |= val << TIME_ROUND_SHIFT;
					break;
				case 7:
					if (have_round)
						state = -2;
					else
						have_round = YES;
					break;
				case 8:
					if (have_lower)
						state = -2;
					else
						have_lower = YES;
					ctime = &lower;
					break;
				case 9:
					if (have_upper)
						state = -2;
					else
						have_upper = YES;
					ctime = &upper;
					break;
				}
		} else {
			state = -2;
#ifdef PSTATE
			fprintf(stderr,"action = error\n");
#endif
		}
	}
	if (state != -2) {
		while (*sptr && isspace(*sptr))
			sptr++;
	}
	if (!have_file && (state == -2 || *sptr))
		return 0;
	if (have_file) {
		if (state == -2 || *sptr) {
			if (save_eot) {
				*save_eot = '\0';
				read_place = save_read_place + ((save_eot - string) - char_count);
				if (read_place >= read_buffer + MAX_STR)
					read_place -= MAX_STR;
			} else {
				read_place = save_read_place;
				return 0;
			}
		}
	}
	if (time == 0 && mask == 0 && !have_none) /* special case - no error and 12:00 am */
		mask |= TIME_TYPE_MIDNIGHT;
#ifdef PSTATE
	fprintf(stderr,"return = %8.8x, mask = %8.8x, time = %d\n",time | mask,mask,time);
#endif
	time |= mask;
	if (mask == TIME_TYPE_NONE) {
		times->word1 = 0;
		times->word2 = 0;
	} else if (time) {
		times->word1 = time;
		times->word2 = (upper << TIME_LIMIT_LATE_SHIFT) | lower;
	} else {
		times->word1 = 0;
		times->word2 = 0;
	}
	return time;
}

#if defined(PROTOTYPES)
char *format_time(int date,time_info_t * time,int format_type)
#else
char *format_time(date,time,format_type)
int date;time_info_t * time;int format_type;
#endif
{
	static char string[MAX_STR];
	char string2[30];
	int jdate;
	int time_incr;
	int time_incr_sign;
	int time_round;
	int time_round_sign;
	int time_type;
	int time_lower;
	int time_upper;
	int sunrise;
	int sunset;
	int sundiff;
	int minutes;
	int hours;
	int minutes2;
	int hours2;
	int proper_time;
	char letter;
	char letter2;
	char *s_type;
	char *splace;

	if (!time || !time->word1)
		return "None";
	time_incr         = time->word1 & TIME_INCR_MASK;
	time_incr_sign    = time->word1 & TIME_INCR_SIGN_MASK;
	time_round        = (time->word1 & TIME_ROUND_MASK) >> TIME_ROUND_SHIFT;
	time_round_sign   = time->word1 & TIME_ROUND_SIGN_MASK;
	time_type         = time->word1 & TIME_TYPE_MASK;
	time_lower	  = time->word2 & TIME_LIMIT_EARLY_MASK;
	time_upper	  = (time->word2 & TIME_LIMIT_LATE_MASK) >> 
				TIME_LIMIT_LATE_SHIFT;
	if (time_type == TIME_TYPE_NONE)
		return "None";
	if (date) {
		jdate = julian_date(current_month,date,current_year);
		sunrise = suntime(jdate,YES);
		sunset = suntime(jdate,NO);
		sundiff = sunset - sunrise;
	}
	switch (time_type) {
		case TIME_TYPE_NORMAL           :
			proper_time = time_incr;
			break;
		case TIME_TYPE_MIDNIGHT         :
			time_type = TIME_TYPE_NORMAL;
			proper_time = 0;
			break;
		case TIME_TYPE_SUNRISE          :
			proper_time = sunrise;
			s_type = "Sunrise";
			break;
		case TIME_TYPE_ZMAN_TEFILA      :
			proper_time = sunrise + (sundiff / 4);
			s_type = "Z'man Tefilah";
			break;
		case TIME_TYPE_HALACHIC_MIDDAY  :
			proper_time = sunrise + (sundiff / 2);
			s_type = "Halachic Midday";
			break;
		case TIME_TYPE_HALACHIC_MIDNIGHT:
			sunrise = suntime(jdate + 1,YES);
			sunrise += 1440;
			sundiff = sunrise - sunset;
			proper_time = sunset + ((sundiff * time_incr) / 1440);
			if (proper_time >= 1440)
				proper_time -= 1440;
			s_type = "Halachic Midnight";
			break;
		case TIME_TYPE_MINCHA_GADOLA    :
			proper_time = sunrise + ((sundiff * 13) / 24);
			s_type = "Mincha Gadolah";
			break;
		case TIME_TYPE_MINCHA_KATANA    :
			proper_time = sunrise + ((sundiff * 19) / 24);
			s_type = "Mincha Katanah";
			break;
		case TIME_TYPE_PLUG_HAMINCHA    :
			proper_time = sunrise + ((sundiff * 43) / 48);
			s_type = "Plug haMincha";
			break;
		case TIME_TYPE_CANDLELIGHTING   :
			proper_time = sunset - 18;
			s_type = "Candlelighting";
			break;
		case TIME_TYPE_SUNSET           :
			proper_time = sunset;
			s_type = "Sunset";
			break;
		case TIME_TYPE_THREE_STARS      :
			proper_time = sunset + 42;
			s_type = "Three Stars";
			break;
		case TIME_TYPE_ZAMIN_DAY        :
			proper_time = sunrise + ((sundiff * time_incr) / 720);
			s_type = "Daytime Zamin";
			break;
		case TIME_TYPE_ZAMIN_NIGHT      :
			sunrise = suntime(jdate + 1,YES);
			sunrise += 1440;
			sundiff = sunrise - sunset;
			proper_time = sunset + ((sundiff * time_incr) / 720);
			if (proper_time >= 1440)
				proper_time -= 1440;
			s_type = "Nighttime Zamin";
			break;
	}
	if (time_type != TIME_TYPE_NORMAL) {
		if (time_incr && time_type != TIME_TYPE_ZAMIN_DAY &&
				time_type != TIME_TYPE_ZAMIN_NIGHT) {
			if (time_incr_sign)
				proper_time -= time_incr;
			else
				proper_time += time_incr;
		if (proper_time < 0)
			proper_time = 0;
		else if (proper_time >= 60 * 24)
			proper_time = (60 * 24) - 1;
		}
		if (time_round) {
			hours = proper_time / 60;
			minutes = proper_time % 60;
			if (!time_round_sign) {
				minutes += time_round - 1;
				if (minutes > 60) {
					hours += 1;
					minutes = 0;
				}
			}
			minutes /= time_round;
			minutes *= time_round;
			proper_time = hours * 60 + minutes;
		}
	}
	if (time_lower && proper_time < time_lower)
		proper_time = time_lower;
	else if (time_upper && proper_time > time_upper)
		proper_time = time_upper;
	hours = proper_time / 60;
	minutes = proper_time % 60;
	if (hours >= 12) {
		letter = 'P';
		hours -= 12;
	} else {
		letter = 'A';
	}
	switch (format_type) {
		case TIME_FORMAT_ABREV  :
			if (hours == 0 && minutes == 0) {
				strcpy(string,letter == 'A' ? "Mnght" : "Noon");
			} else {
				if (minutes == 0)
					sprintf(string,"%d%cM",hours,letter);
				else
					sprintf(string,"%d:%2.2d%cM",
						hours,minutes,letter);
			}
			break;
		case TIME_FORMAT_CLIPPED  :
			if (hours == 0 && minutes == 0) {
				strcpy(string,letter == 'A' ? 
					"Mnght" : "Noon");
			} else {
				if (hours == 0)
					hours += 12;
				sprintf(string,"%d:%2.2d",hours,minutes);
			}
			break;
		case TIME_FORMAT_SHORT  :
do_short_time:
			if (hours == 0 && minutes == 0) {
				strcpy(string,letter == 'A' ? 
					"Midnight" : "Noon");
			} else {
				if (hours == 0)
					hours += 12;
				sprintf(string,"%d:%2.2d %cM",
					hours,minutes,letter);
			}
			break;
		case TIME_FORMAT_ACTUAL :
		case TIME_FORMAT_FULL   :
			if (time_type == TIME_TYPE_NORMAL)
				goto do_short_time;
			if (time_type == TIME_TYPE_ZAMIN_DAY ||
					time_type == TIME_TYPE_ZAMIN_NIGHT) {
				sprintf(string,"%d:%2d %s",time_incr / 60,
						time_incr % 60,s_type);
			} else {
				strcpy(string,s_type);
				if (time_incr) {
					sprintf(string2," %c %d minutes",
					time_incr_sign ? '-' : '+',time_incr);
					strcat(string,string2);
				}
			}
			if (time_round) {
				sprintf(string2," rounded %s %d minutes",
					time_round_sign ? "down" : "up",
					time_round);
				strcat(string,string2);
			}
			if (time_lower) {
				hours2 = time_lower / 60;	
				minutes2 = time_lower % 60;	
				if (hours2 > 11) {
					hours2 -= 12;
					letter2 = 'P';
				}
				sprintf(string2," minimun %d:%2.2d %cM",
						hours2,minutes2,letter2);
				strcat(string,string2);
			}
			if (time_upper) {
				hours2 = time_upper / 60;	
				minutes2 = time_upper % 60;	
				if (hours2 > 11) {
					hours2 -= 12;
					letter2 = 'P';
				}
				sprintf(string2," maximun %d:%2.2d %cM",
						hours2,minutes2,letter2);
				strcat(string,string2);
			}
			if (format_type == TIME_FORMAT_FULL) {
				strcat(string," (");
				if (hours == 0 && minutes == 0) {
					strcat(string,letter == 'A' ? 
						"Midnight" : "Noon");
				} else {
					sprintf(string2,"%d:%2.2d %cM",
						hours,minutes,letter);
					strcat(string,string2);
				}
				strcat(string,")");
			}
			break;
	}
	return string;
}

#ifndef BATCH
#if defined(PROTOTYPES)
void mlist_set_time(int date,cur_mlist_t *item,time_info_t *time) {
#else
void mlist_set_time(int date,item,time) cur_mlist_t *item;time_info_t *time; {
#endif
	int	 slen;
	char	*stime;

	item->i_answer = time->word1;
	item->i_lower = time->word2;
	stime = format_time(date,time,date?TIME_FORMAT_FULL:TIME_FORMAT_ACTUAL);
	slen = strlen(stime) + 1;
	if (slen >= item->s_answer_size) {
		item->s_answer = realloc(item->s_answer,slen);
		item->s_answer_size = slen;
	}
	strcpy(item->s_answer,stime);
}

#if defined(PROTOTYPES)
void get_time(cur_mlist_t *item) {
#else
void get_time(item) cur_mlist_t *item; {
#endif
	int		 select;
	time_info_t 	 time;
	char	       **tptr;
	cur_slist_t	*slist_name;
	char		*type_name;
	char		 message[MAX_STR];

	sprintf(message,"Time '%s' not in proper format - getting manually",item->name);
	cur_msg_win(message);
	if (!time_types_slist) {
		for (tptr = time_types;*tptr;tptr++)
			time_types_slist =cur_slist_add(time_types_slist,*tptr);
	}
	select = 1;
	slist_name = cur_slist_fancy("Type of time desired",time_types_slist,
			select,&select);
	type_name = slist_name->string;
	switch (select) {
		case  1:  /* None */
			time.word1 = 0;
			time.word2 = 0;
			break;
		case  2:  /* Normal */
			get_time_normal(&time,"Regular time");
			break;
		case  3:  /* Noon */
			time.word1 = 12 * 60;
			time.word2 = 0;
			break;
		case  4:  /* Midnight */
			time.word1 = TIME_TYPE_MIDNIGHT;
			time.word2 = 0;
			break;
		case  5:  /* Sunrise */
			get_time_zamin(TIME_TYPE_SUNRISE,type_name,
					&time);
			break;
		case  6:  /* Zman tefilah */
			get_time_zamin(TIME_TYPE_ZMAN_TEFILA,type_name,
					&time);
			break;
		case  7:  /* Halachic midday */
			get_time_zamin(TIME_TYPE_HALACHIC_MIDDAY,type_name,
					&time);
			break;
		case  8:  /* Halachic midnight */
			get_time_zamin(TIME_TYPE_HALACHIC_MIDNIGHT,type_name,
					&time);
			break;
		case  9:  /* Mincha gadola */
			get_time_zamin(TIME_TYPE_MINCHA_GADOLA,type_name,
					&time);
			break;
		case 10:  /* Mincha katana */
			get_time_zamin(TIME_TYPE_MINCHA_KATANA,type_name,
					&time);
			break;
		case 11:  /* Plug hamincha */
			get_time_zamin(TIME_TYPE_PLUG_HAMINCHA,type_name,
					&time);
			break;
		case 12:  /* Candlelighting */
			get_time_zamin(TIME_TYPE_CANDLELIGHTING,type_name,
					&time);
			break;
		case 13:  /* Sunset */
			get_time_zamin(TIME_TYPE_SUNSET,type_name,
					&time);
			break;
		case 14:  /* Three stars */
			get_time_zamin(TIME_TYPE_THREE_STARS,type_name,
					&time);
			break;
		case 15:  /* Zamin day */
			get_time_zday(TIME_TYPE_ZAMIN_DAY,type_name,
					&time);
			break;
		case 16:  /* Zamin night */
			get_time_zday(TIME_TYPE_ZAMIN_NIGHT,type_name,
					&time);
			break;
	}
	mlist_set_time(0,item,&time);
}


#if defined(PROTOTYPES)
int get_time_normal(time_info_t *time,char *title) {
#else
int get_time_normal(time,title)time_info_t *time; char *title {
#endif
	cur_mlist_t	*mptr;

	time->word2 = 0;
	time->word1 = 0;
	if (!menu_time_regular)
		menu_time_regular = mk_menu(menu_list_time_regular);
	cur_menu_reset(menu_time_regular);
	if (!cur_menu_ask(title,menu_time_regular,NULL))
		return 0;
	mptr = menu_time_regular;
	time->word1 = mptr->i_answer * 60;
	mptr = mptr->next;
	time->word1 += mptr->i_answer;
	mptr = mptr->next;
	if (*mptr->s_answer == 'P')
		time->word1 += 12 * 60;
	return time->word1;
}

#if defined(PROTOTYPES)
int get_time_zamin(int type,char *name,time_info_t *time) {
#else
int get_time_zamin(type,name,time); int type;char *name;time_info_t *time;{
#endif
	cur_mlist_t	*mptr;
	time_info_t	 ltime;

	time->word1 = 0;
	time->word2 = 0;
	if (!menu_time_zamin)
		menu_time_zamin = mk_menu(menu_list_time_zamin);
	cur_menu_reset(menu_time_zamin);
	cur_mlist_set(menu_time_zamin,name);

	if (!cur_menu_ask("Zamin based time",menu_time_zamin,NULL))
		return 0;

	time->word1 = type;
	mptr = menu_time_zamin->next;
	if (mptr->i_answer < 0) {
		time->word1 |= TIME_INCR_SIGN_MASK;
		mptr->i_answer = -mptr->i_answer;
	}
	time->word1 |= mptr->i_answer;

	mptr = mptr->next;
	if (mptr->i_answer < 0) {
		time->word1 |= TIME_ROUND_SIGN_MASK;
		mptr->i_answer = -mptr->i_answer;
	}
	time->word1 |= mptr->i_answer << TIME_ROUND_SHIFT;

	mptr = mptr->next;
	if (mptr->i_answer == 1) {
		if (get_time_normal(&ltime,"Minimun Time")) {
			time->word2 = ltime.word1;
		}
	}

	mptr = mptr->next;
	if (mptr->i_answer == 1) {
		if (get_time_normal(&ltime,"Maximun Time")) {
			time->word2 |= ltime.word1 << TIME_LIMIT_LATE_SHIFT;
		}
	}

	return time->word1;
}

#if defined(PROTOTYPES)
int get_time_zday(int type,char *name,time_info_t *time) {
#else
int get_time_zday(type,name,time); int type;char *name;time_info_t *time;{
#endif
	cur_mlist_t	*mptr;
	time_info_t	 ltime;

	time->word1 = 0;
	time->word2 = 0;
	if (!menu_time_zamin_day)
		menu_time_zamin_day = mk_menu(menu_list_time_zamin_day);
	cur_menu_reset(menu_time_zamin_day);
	cur_mlist_set(menu_time_zamin_day,name);

	if (!cur_menu_ask("Zamin based time",menu_time_zamin_day,NULL))
		return 0;

	mptr = menu_time_zamin_day->next;
	time->word1 |= mptr->i_answer * 60;

	mptr = mptr->next;
	time->word1 += mptr->i_answer;

	time->word1 |= type;

	mptr = mptr->next;
	if (mptr->i_answer < 0) {
		time->word1 |= TIME_ROUND_SIGN_MASK;
		mptr->i_answer = -mptr->i_answer;
	}
	time->word1 |= mptr->i_answer << TIME_ROUND_SHIFT;

	mptr = mptr->next;
	if (mptr->i_answer == 1) {
		if (get_time_normal(&ltime,"Minimun Time")) {
			time->word2 = ltime.word1;
		}
	}

	mptr = mptr->next;
	if (mptr->i_answer == 1) {
		if (get_time_normal(&ltime,"Maximun Time")) {
			time->word2 |= ltime.word1 << TIME_LIMIT_LATE_SHIFT;
		}
	}

	return time->word1;
}

#endif
